<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     openReport.jsp
// AUTHOR:   sasrop - Ronald Page
// SUPPORT:  sasrop - Ronald Page
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  Frame jsp to set up report viewing
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           21Sep00  rop  initial coding
// S0128871  22Oct01  lmd  show acrobat required message
/*********************************************************************/
%>
<%@ include file="HRVLoginInclude.jsp"%>

<%
	ReportBean rb = new ReportBean(session);
	rb.setMetaKey( request.getParameter("key") );
	int location = MetaBean.PUBLIC_LOC;
	String loc = request.getParameter("location");
	if( loc != null && loc.equalsIgnoreCase( MetaBean.PRIVATE_LOC_STRING ))
		location = MetaBean.PRIVATE_LOC;
	else if( loc != null && loc.equalsIgnoreCase( MetaBean.APPL_LOC_STRING ))
		location = MetaBean.APPL_LOC;
	rb.setMetaLocation( location );
	String auto = request.getParameter("autorefresh");

	String reporttables = rb.getAttributeValue("reporttables");
	String tblLoc = null;
	String tblKey = null;

	// If not built from a user-prompted query
	if (reporttables == null || reporttables.equals("")) {

		tblLoc = rb.getAttributeValue("tableloc");

		// If a report builder report built from a user prompt
		if (tblLoc != null) {
			tblKey = rb.getAttributeValue("tablekey");
			reporttables = tblLoc + "_" + tblKey;
		}
	}

	// If a user prompt is involved in the included table
	if (rb.isPrompted()) {

		// Get the location and the table key
		tblLoc = reporttables.substring(0,1);
		tblKey = reporttables.substring(2);

		TableBean tb = new TableBean(session);
		tb.setMetaLocation(Integer.parseInt(tblLoc));
		tb.setMetaKey(tblKey);
		String tblType = tb.getAttributeValue("tbltype");
		NamedList nl = tb.getUserPrompts();

		// If this is a user-prompted query
		if (tblType != null && tblType.equalsIgnoreCase("query") && nl != null && nl.size() > 0) {

			OptionBean ob = OptionBean.getInstance(session);
			String promptUser = ob.getOption("promptuser");

			// if user wants prompts to run while opening...
			if (promptUser != null && promptUser.equalsIgnoreCase("y")) {

				// now determine if the userpromt has just been run.
				String dwup = request.getParameter("doneWithUP");
				boolean doneWithUP = false;
				if (dwup != null && dwup.equalsIgnoreCase("Y"))
					doneWithUP = true;
				if (!doneWithUP) {
					// user prompt has not run yet, so run it.
					String comeBack = "../Jsp/openReport.jsp?" + request.getQueryString() + "&force=Y";
					hrvi.setSessionValue(session,"sentToRefreshFromOpen",comeBack);
					String fwdTo = "../Jsp/refreshTable.jsp?from=open&type=tables&topic=ALL&key=" + tblKey + "&location=" + 	tblLoc;
					forwardURL(fwdTo,out,request,response);
					return;
				}
			}
			else {
				// don't want to prompt the user upon opening the query.
				// need to set doneWithUP to Y so that dwdata is used as the library to look for the ds in.
				session.setAttribute("doneWithUP","Y");
			}
		}
	}

	// Otherwise if not being called to autorefresh
	else if (auto == null) {

		// If reportSecurity="off"
		if (!rb.isSecure()) {

			// If report is public
 			if (rb.isMetaLocationPublic()) {

				// Delete any lingering private output that might still persist
				rb.deleteOutput(true);
			}
			// Otherwise if report is private and output isn't currently there
			else if (!rb.isOutputCurrent()) {

				// Reenter this jsp to force a refresh before display
				String fwdTo = "../Jsp/openReport.jsp?" + request.getQueryString() + 	"&force=Y&autorefresh=Y";
				forwardURL(fwdTo,out,request,response);
				return;
			}
		}

		// Otherwise if reportSecurity="on" and report output isn't there
		else if (!rb.isOutputCurrent()) {

			// Reenter this jsp to force a refresh before display
			String fwdTo = "../Jsp/openReport.jsp?" + request.getQueryString() + "&force=Y&autorefresh=Y";
			forwardURL(fwdTo,out,request,response);
			return;
		}
	}

	HrvJspStructure jspStruct = new HrvJspStructure(session);

	jspStruct.msgPrefixKey = "REP";
	jspStruct.leftMenuKey  = "";
	jspStruct.forwardParms = true;
	jspStruct.banner       = HrvJspStructure.ALT_BANNER;
	jspStruct.showLoadMsg  =true;

	// determine if this is a PDF report
	String type = rb.getAttributeValue( ReportBean.OUTPUTTYPE );
	if( type != null && type.equalsIgnoreCase( "PDF" ))
		jspStruct.showAcrobatMsg=true;
%>

<html><head>

<%
   PrintWriter PWout = new PrintWriter(out);
	jspStruct.write( PWout, request );
%>
