<%@page import="com.sas.query.Query"%>

<%!
   /**
    * Returns the image filename representing data of the given data type.
    * Note: these should probably be drawn from resource bundles!
    */
   public String getImageForType(int dataType) {
      String retval = null;

      switch (dataType) {
         case ExpressionConstants.EXP_TYPE_NUMERIC:
            retval = "typeNum.gif";
            break;
         case ExpressionConstants.EXP_TYPE_CHARACTER:
            retval = "typeChar.gif";
            break;
         case ExpressionConstants.EXP_TYPE_DATE:
            retval = "typeDate.gif";
            break;
         case ExpressionConstants.EXP_TYPE_TIME:
            retval = "typeTime.gif";
            break;
         case ExpressionConstants.EXP_TYPE_TIMESTAMP:
            retval = "typeTimeStamp.gif";
            break;
         default:
            retval = "Column.gif";
      }
      return retval;
   }

   public ColumnList getResultItemColumns(HRVQuery query) {
      return query.getResultItemColumns(query);
   }

   public String getLabelForDataItem(DataItem item, VisMsg bundle, String formatName)
   {
      if (item instanceof JspDataItem) {
System.out.println("Deprecated call to getLabelForDataItem!  item="+item.toString());   //BKD:FIX - change the call
     return getLabelForDataItem((JspDataItem)item, bundle, formatName);
      } else {
         throw new IllegalArgumentException("DataItem was not a JspDataItem!");
      }
   }

   public String getLabelForDataItem(JspDataItem item, VisMsg bundle, String formatName)
   {
      String itemLabel = null;
      Expression expression = item.getSafeExpression();

      if (expression instanceof ColumnExpression) {
     //simple column expression
     Column column = ((ColumnExpression)expression).getColumn();
     com.sas.query.models.Table table = column.getParent();
     String libName = table.getDataSourceTable().getParent().getName();
     String tableName = table.getDisplayName();
     String columnDesc = item.getLabel();
     String columnName = column.getName();
     String tableDesc = ((HRVDataSourceTable)table.getDataSourceTable()).getDescription();

     if (columnDesc == null)
        columnDesc = item.getDisplayString();
     itemLabel = messageFormat(bundle, formatName, libName, tableName, columnDesc, tableDesc, columnName);
      } else {
     //probably a calculated column
     itemLabel = item.getLabel();
     if (itemLabel == null)
        itemLabel = item.getDisplayString();
      }

      return itemLabel;
   }

   public String messageFormat(VisMsg bundle, String formatName, Object arg1, Object arg2, Object arg3, Object arg4, Object arg5)
   {
      return messageFormat(bundle, formatName, arg1, arg2, arg3, arg4, arg5, null);
   }

   public String messageFormat(VisMsg bundle, String formatName, Object arg1, Object arg2, Object arg3, Object arg4, Object arg5, Object arg6)
   {
      String pattern = bundle.getLabel( formatName );
      Object [] args = {arg1, arg2, arg3, arg4, arg5, arg6 };
      return java.text.MessageFormat.format( pattern,args );
   }

   /**
    * Encode special characters withing the given string using standard HTML
    * constructs.  Many non-alphanumeric characters have an 'escaped' HTML
    * construct that will be appropriately handled by browsers and
    * web-servers.
    * @return the encoded string
    */
   public String htmlEncode(String input) {
      if (input == null)
     return null;

      StringBuffer buf = new StringBuffer(input.length());
      for (int i=0; i<input.length(); i++) {
     char ch = input.charAt(i);
     switch (ch) {
        case '<':
           buf.append("&lt;");
           break;
        case '>':
           buf.append("&gt;");
           break;
        case '&':
           buf.append("&amp;");
           break;
        case '"':
           buf.append("&quot;");
           break;
        case (char)161:
           buf.append("&iexcl;");
           break;
        case (char)162:
           buf.append("&cent;");
           break;
        case (char)163:
           buf.append("&pound;");
           break;
        case (char)164:
           buf.append("&curren;");
           break;
        case (char)165:
           buf.append("&yen;");
           break;
        case (char)166:
           buf.append("&brvbar;");
           break;
   /*
   //There are many more...
   //see http://developer.netscape.com/docs/manuals/htmlguid/tags22.htm
   // for a complete listing...
   */
        default:
           buf.append((char)ch);
     }
      }

      return buf.toString();
   }

   /**
    * Constructs a parameter string that can be added to a URL to supply the
    * appropriate form data.
    * @param params A Hashtable of key/value or key/values sets.  The key is
    * the name of a paramter and the value should be a String or String array
    * to specify multiple values for a given named parameter.
    *
    * @return the parameter string constructed from the supplied Hashtable of
    * key/value(s).
    */
   public String buildParameterString(Map params)
   {
      StringBuffer paramString = new StringBuffer();

      //there may be some parameters we need to add to the next URL
      if (params.size() > 0) {
     Iterator iterator = params.entrySet().iterator();
     //step over the list of these parameters and add them to the URL
     while (iterator.hasNext()) {
        Map.Entry entry = (Map.Entry)iterator.next();
        String key = (String)entry.getKey();
        //some entries may be arrays of Strings
        if (entry.getValue() instanceof String[]) {
           String[] values = (String[])entry.getValue();
           for (int i=0; values != null && i<values.length; i++) {
          if (paramString.length() > 0)
             paramString.append('&');
          String value = values[i];
          if (value == null)
             value = "";
          paramString.append(key).append('=').append(value);
           }
        } else {    //others just a single value
           Object value = entry.getValue();
           if (value == null)
          value = "";
           if (paramString.length() > 0)
          paramString.append('&');
           paramString.append(key).append('=').append(value.toString());
        }
     }
      }

      return paramString.toString();
   }

   public String getRedirectURL(VisMsg bundle, String stepToGoto, HashMap riders) {
      //Get the URL base from the resource bundle
      String key = "Query.Step."+stepToGoto+".url";
      String nextURL = bundle.getSentence(key);
      //The URL should not be the same as going in, but it could be...
      if (nextURL == null || key.equals(nextURL)) {
     nextURL = "";  //BKD:FIX should this be an error instead?
     //BKD:FIX if we keep this warning, we should localize the message!
//BKD:DEBUG /* not tomcat friendly */    application.log("Could not find URL for step: "+ stepToGoto);//BKD:DEBUG
      }

      //There may be parameters we need to add to the next URL
      String paramString = buildParameterString(riders);
      //There might be parameters already on the URL
      if (nextURL.indexOf("?") == -1)
     nextURL = nextURL + "?" + paramString;
      else
     nextURL = nextURL + "&" + paramString;

      return nextURL;
   }

   public boolean isValid(HRVDataSourceTable table)
   {
      return table.isValid();
   }

   public boolean isValid(HttpSession session, HRVDataSourceTable table, String columnName)
   {
//      com.sas.sasserver.dataset.DataSetInterface dsI = table.getModelInterface();
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
      com.sas.sasserver.dataset.DataSetInterface dsI = null;

try {
      ConnectionInterface cI = ConnectionInterface.getInstance(session);
      com.sas.rmi.Rocf rocf = cI.getRocf();
      com.sas.rmi.Connection con = cI.getCon();

      dsI = (com.sas.sasserver.dataset.DataSetInterface)rocf.newInstance(com.sas.sasserver.dataset.DataSetInterface.class, con);

      String viewName = table.convertToView();
      dsI.setDataSet(viewName);
} catch (Exception e) {
   System.err.println("Exception: " + e.getMessage());
   e.printStackTrace();
}
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
      if (dsI != null) {
         try {
        int colIndex = dsI.getColumnIndex(columnName);
        dsI.close();
        return true;
     } catch(IllegalArgumentException iae) {
        //column not in dataset
     } catch(com.sas.table.TableException te) {
        //index info cannot be retrieved - this is bad too, though...
     } finally {
        dsI.close();
     }
      }

      return false;
   }


   /**
    * Returns a list of functions for the given DataItem based on data type
    * and configurable resources.
    */
   public FunctionList getFunctionListForDataItem(HRVQuery query, DataItem item, VisMsg bundle)
   {
      int dataType = Expression.EXP_TYPE_UNKNOWN;
      if (item != null) {
//           dataType = item.getExpression().getDataType();
     if (item.getExpression() instanceof ColumnExpression)
        dataType = getDataType(query, item);
     else
        dataType = Expression.EXP_TYPE_UNKNOWN;
      }

      return getFunctionListForDataItem(query, dataType, bundle);
   }

   /**
    * Returns a list of functions for the given data type based on
    * configurable resources.
    */
   public FunctionList getFunctionListForDataItem(Query query, int dataType, VisMsg bundle)
   {
      FunctionList functionList = new FunctionList();
      FunctionList allFuncs = query.getDataSourceFunctions().getSubsetByFunctionType( FunctionConstants.FUN_AGGREGATE );
      String funcListTxt = null;

      switch (dataType) {
     case Expression.EXP_TYPE_CHARACTER:
        funcListTxt = bundle.getString("Display.FunctionList.Character.notrans");
        break;
     case Expression.EXP_TYPE_DATE:
     case Expression.EXP_TYPE_TIME:
     case Expression.EXP_TYPE_TIMESTAMP:
        funcListTxt = bundle.getString("Display.FunctionList.Date.notrans");
        break;
     case Expression.EXP_TYPE_NUMERIC:
     case Expression.EXP_TYPE_UNKNOWN:
        funcListTxt = bundle.getString("Display.FunctionList.Numeric.notrans");
        break;
     default:
        //BKD:FIX - use resource?  keep message?
//           application.log("Warning- DataType not accounted for: " + dataType);
      }

      if (funcListTxt != null) {
     StringTokenizer st = new StringTokenizer(funcListTxt, ",");
     while (st.hasMoreTokens()) {
        String funcName = st.nextToken();
        if ("group".equalsIgnoreCase(funcName)) {
           //BKD:FIX - what? we're not including group as a function
           //anymore.
        } else {
           FunctionList shortList = allFuncs.getSubsetByName(funcName);
           if (shortList.size() > 0) {
          functionList.addElement(shortList.elementAt(0));
           }
        }
     }
      }

      return functionList;
   }

   public String getHRVMessageText(HttpSession session, String tableName)
   {
      com.sas.sasserver.dataset.DataSetInterface dsI = null;
      String hrvMsg = null;

      try {
     ConnectionInterface cI = ConnectionInterface.getInstance(session);
     com.sas.rmi.Rocf rocf = cI.getRocf();
     com.sas.rmi.Connection con = cI.getCon();

     dsI = (com.sas.sasserver.dataset.DataSetInterface)rocf.newInstance(com.sas.sasserver.dataset.DataSetInterface.class, con);
     dsI.setDataSet(tableName);

     //need 1 column...
     if (dsI.getColumnCount() == 1 || (dsI.getColumnCount() == -1 && dsI.countColumns(2) == 1)) {
        //...and 1 row
        if (dsI.getRowCount() == 1 || (dsI.getRowCount() == -1 && dsI.countRows(2) == 1)) {
           int msgIndex = dsI.getColumnIndex("MSG");
           //column name should be "MSG"
           if (msgIndex == 1) {
              // read the return code.
         hrvMsg = (String) dsI.getCell(1, 1);
           }
        }
     }
      /*
      } catch (IllegalArgumentException e) {
         //invalid dataset or column given
      */
      } catch (Exception e) {
     System.err.println("Exception: " + e.getMessage());
     e.printStackTrace();
      }

      if (dsI != null)
         dsI.close();

      return hrvMsg;            //return what we found or null
   }

   public void multiSort(com.sas.collection.StringCollection[] collections, int sortIndex)
   {
      com.sas.util.Comparator c = new com.sas.util.StringComparator(true, false);

      multiSort(collections, sortIndex, c, 0, collections[sortIndex].count() - 1);
   }

   /**
    * Modified quick sort from that found in com.sas.util.Sort.
    */
   public void multiSort(com.sas.collection.StringCollection[] collections, int sortIndex, com.sas.util.Comparator comparator, int start, int end)
   {
      int lo = start;
      int hi = end;
      Object mid;

      if ( end > start ) {
         /* Arbitrarily establishing partition element as the midpoint of
         * the array.
         */
         mid = collections[sortIndex].get( ( start + end ) / 2 );

         // loop through the array until indices cross
         while( lo <= hi ) {
            /* find the first element that is greater than or equal to
             * the partition element starting from the left Index.
             */
            while(    ( lo < end )
                   && ( comparator.compare(collections[sortIndex].get(lo), mid) < 0 ) )
           ++lo;

            /* find an element that is smaller than or equal to
             * the partition element starting from the right Index.
             */
            while(    ( hi > start )
                   && ( comparator.compare(collections[sortIndex].get(hi), mid) > 0 ) )
           --hi;

            // if the indexes have not crossed, swap
            if( lo <= hi ) {
           for (int i=0; i<collections.length; i++) {
          multiSortSwap(collections[i], lo, hi);
           }
           ++lo;
           --hi;
        }
     }

     /* If the right index has not reached the left side of array
     * must now sort the left partition.
     */
     if( start < hi )
        multiSort(collections, sortIndex, comparator, start, hi );

     /* If the left index has not reached the right side of array
     * must now sort the right partition.
     */
     if( lo < end )
        multiSort(collections, sortIndex, comparator, lo, end );
      }
   }

   protected void multiSortSwap(com.sas.collection.StringCollection c, int a, int b)
   {
      String temp = c.getString(a);
      c.setString(a, c.getString(b));
      c.setString(b, temp);
   }

   /**
    * Returns the data type for the given data item.  The return value will be
    * a constant from the com.sas.query.models.ExpressionConstants interface.
    * The value will be determined by the data type of the underlying column
    * used by the expression stored in the DataItem instance.  In the case of
    * calculated columns where multiple columns are referenced, the return
    * value will be EXP_TYPE_UNKNOWN, unless the data type can be determined.
    */
   public int getDataType(HRVQuery query, DataItem item)
   {
      int dataType = ExpressionConstants.EXP_TYPE_UNKNOWN;

      //break the item's expression down to its atoms
      ExpressionList itemExpressions = query.getExpressionList(item.getExpression());
      ExpressionList columnExpressions = ((HRVDataSource)query.getDataSource()).getExpressionsByClass(itemExpressions, ColumnExpression.class);
      if (columnExpressions.size() == 1) {
         ColumnExpression ce = (ColumnExpression)columnExpressions.elementAt(0);
     dataType = ce.getColumn().getDataType();
      }

      return dataType;
   }

   /**
    * Gives a best guess as to whether the specified data item represents a
    * calculated column or not.
    */
   public boolean isCalculatedColumn(HRVQuery query, JspDataItem item)
   {
      /*
      if (getDataType(query, item) != ExpressionConstants.EXP_TYPE_UNKNOWN) {
         return false;
      }
      */

      //see if the result item expression is a ColumnExpression - anything
      //else is likely to be a calculated column.  It's possible to generate a
      //ColumnExpression via a calculated column by making the expression
      //consist solely of the name of an available column.
      try{
      	if (item.getExpression() != null && item.getExpression() instanceof ColumnExpression) {
         	return false;
      	}
	  }catch(Exception e){
		  return false;
	  }

      return true;
   }

   /**
    * Returns true if a ParameterExpression is included in the query model.
    */
   public boolean hasUserPrompt(HRVQuery query)
   {
      boolean hasPrompt = false;

      if (query != null) {
         ExpressionList el = ((HRVDataSource)query.getDataSource()).getExpressionsByClass(query.getExpressions(), ParameterExpression.class);
     if (el.size() > 0)
        hasPrompt = true;
      }

      return hasPrompt;
   }

   public int getInt(VisMsg bundle, String key)
   {
      return getInt(bundle, key, 0);
   }
   public int getInt(VisMsg bundle, String key, int notFoundReturnValue)
   {
      String strValue = null;
      try {
         strValue = bundle.getSentence(key);
     return (Integer.parseInt(strValue));
      } catch (Throwable t) {
         //missing resource
      }

      return notFoundReturnValue;
   }
%>
