<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %> 
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.Checkbox" %>
<%@ page import="com.sas.servlet.beans.html.Choicebox" %>
<%@ page import="com.sas.servlet.beans.html.Listbox" %>
<%@ page import="com.sas.servlet.beans.html.Radio" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%!
   //The values for the 2 libraries will remain the same no matter what locale
   //we are in.
   static StringCollection librarySelectorModel = new StringCollection();
   static {
      librarySelectorModel.add("public");   //public library
      librarySelectorModel.add("private");  //private library
   }

   static StringCollection joinSelectorModel = new StringCollection();
   static {
      joinSelectorModel.add("inner");   //inner join
      joinSelectorModel.add("left");    //left join
   }

   //This value will be used for the custom attributes for the library selector bean in the simple view.
   //This value will cause the list of available tables to be updated when a library choice is selected.
   static String librarySelectorCustomAttributes = "OnClick=\"OnChangeLibrary()\"";
   static String labelSelectorCustomAttributes = "OnClick=\"OnChangeLibrary()\"";
%>
<%
// Variables
////////////////////////////////////////////////////////////////////////////////
   VisMsg bundle = null;    //The resource bundle for this page
   HashMap riders = null;   //Parameters that we should propagate
   String action = null;    //The action parameter "intAction"
   String stepToGoto = null;    //If action is "goto", this is the step to goto
   boolean hasError = false;    //Flag for errors on page
   int location = MetaBean.PUBLIC_LOC;  //Current library 
   ExplorerCustomize explorer = null;   //HR vision's explorer interface

   //Get the resource bundle from the request object
   bundle = (VisMsg)request.getAttribute("resources");
   riders = new HashMap();  //Create the riders list
   riders.put("sessionkey", m_sessionKey);  //Always remember the session key

////////////////////////////////////////////////////////////////////////////////
// DETERMINE ACTION    
// 
// Possible actions are:  
//   None - no action given
//  There will be no action value if this is the first page in a new
//  query, or if the user moved from another step.
//   Update - need to update the query model from form data
//  This action will take place when the user switchs libraries, adds
//  tables(s), or removes tables(s).
//   Goto - request to go to another step
//  This action value will occur if the user selects any of the step links
//  from the menu on the left of the window, or hits the [Edit SQL] or
//  [Add Calculated Column] buttons at the bottom of the window.
////////////////////////////////////////////////////////////////////////////////
   //Check the intAction parameter
   action = request.getParameter("intAction");
   if (action != null) {
      //if the action is not 'none', then it will either be 'goto' or 'update'
      if (action.startsWith("goto.")) {
     stepToGoto = action.substring(5);  //save the step
         action = "goto";           //set the action to "goto"
      } else {
         action = "update";         //set the action to "update"
      }
   }

////////////////////////////////////////////////////////////////////////////////
// PROCESS FORM DATA
//
// We need to gather these items from the form data:
//  Selected library
//  Selected table(s)
//  Selected column(s) and expression(s)
////////////////////////////////////////////////////////////////////////////////
   String[] msg_p = request.getParameterValues("msg");
   if (msg_p != null) {
      for (int i=0; i<msg_p.length; i++) {
         msg_p[i] = msg_p[i].trim();
         request.setAttribute("msg."+msg_p[i], bundle.getString("ColumnSelector.Message."+msg_p[i]));
      }
   }

   //we should only process form data if the user has submitted the form.
   //Otherwise, we may be removing valuable items from the query.
   //////////////////////////////////////// BEGIN PROCESS DATA ////////////////////////////////////////
   if (action != null) {
      String library_p = request.getParameter("library");
      String label_p = request.getParameter("label");
      String join_p = request.getParameter("join");
      String[] chosenTables_p = request.getParameterValues("tableKeys");
      String[] chosenColumns_p = request.getParameterValues("columnKeys");
      
      //##########maperr 5/5/04 Adding prompt info to table xml #####################
      String usePrompt = request.getParameter("prompt");
      TableBean tb = m_query.getWorkingTableBean();
      
      if(usePrompt != null && "Y".equalsIgnoreCase(usePrompt)){
          tb.setAttributeValue("useprompt", "true");
      }else{
          //remove prompt
          tb.setAttributeValue("useprompt", "false");
      }
      tb.write();
      //#############################################################################

      //check label flag
      m_query.setShowLabels((label_p != null && "Y".equalsIgnoreCase(label_p)));

      //location will be either public or private (public by default)
      if ("private".equals(library_p))
         location = MetaBean.PRIVATE_LOC;

      ////////////////////////////////////////////////////////////////////////////////
      // PROCESS SELECTED TABLES
      ////////////////////////////////////////////////////////////////////////////////
      TableList postProcessTables = new TableList();
      //if 1 or more tables were selected, then process the list to see what has been added/removed
      if (chosenTables_p != null) {
     TableList toBeAdded = new TableList();

     for (int i=0; i<chosenTables_p.length; i++) {
        String tableKey = chosenTables_p[i];    //The current table key
        Table table = null;             //The eventual Table object
        if (tableKey.startsWith("@")) {
           //this is an existing table - format=@II.HH where II is the index value and HH is the hash code in HEX
           String indexStr = null;
           String hexHashStr = null;
           int hashCode = -1;
           int pos = -1;

           pos = tableKey.indexOf('.');
           if (pos > 0 && pos < tableKey.length()) {
          indexStr = tableKey.substring(1, pos);
          hexHashStr = tableKey.substring(pos + 1);
          try {
             hashCode = Integer.parseInt(hexHashStr, 16);

             //search table list for existing table reference
             TableList tl = m_query.getTables();
             for (int j=0; j<tl.size(); j++) {
            Table existingTable = tl.elementAt(j);
            if (existingTable.hashCode() == hashCode) {
               table = existingTable;   //found it - save reference
               break;           //no need to keep looking
            }
             }
          } catch (NumberFormatException nfe) {
          }
           }
        } else {
           //this is a new table
           DataSourceTable dst = m_dataSource.getTable(tableKey);
            if (dst == null)
            {
                HRVDataSourceContainer container;
                if (location == MetaBean.PUBLIC_LOC)
                   container = (HRVDataSourceContainer)m_dataSource.getItems().elementAt(0);
                else
                   container = (HRVDataSourceContainer)m_dataSource.getItems().elementAt(1);
                dst = new HRVDataSourceTable(session, container, tableKey.substring(tableKey.indexOf(".")+1), location);
                container.getItems().addElement(dst);
            }
            table = new Table(m_query, dst);
            toBeAdded.addElement(table);
            m_query.addTable(table);
//           if (dst != null) {
//          table = new Table(m_query, dst);
//          toBeAdded.addElement(table);
//          m_query.addTable(table);
//           }
        }

        //check to see if a valid Table object was identified
        if (table != null) {
           postProcessTables.addElement(table);
        } else {
           //then something bad has happened... :(
           //unrecognized table, so should report the inability to add table to query to user.
        }
     }
      }

      //Now figure out what tables need to be removed
      TableList queryTables = m_query.getTables();
      for (int i=queryTables.size(); i>0; i--) {
     Table table = queryTables.elementAt(i-1);
     if (!contains(postProcessTables, table)) {
        //remove the table and everything it touches
        m_query.deleteTable(table);     //delete from query
        //BKD:FIX delete from persisted items too!
     }
      }
      ////////////////////////////////////////////////////////////////////////////////

      ////////////////////////////////////////////////////////////////////////////////
      // PROCESS SELECTED COLUMNS
      ////////////////////////////////////////////////////////////////////////////////
      DataItemList postProcessItems = new DataItemList();
      DataItemList queryItems = m_query.getPersistedItemList();
      int resultItemCount = 0;
      int itemCount = 0;
      //if 1 or more columns were selected, then process the list to see what has been added/removed
      if (chosenColumns_p != null) {
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
     DataItemList keepers = new DataItemList();
     for (int i=0; i<chosenColumns_p.length; i++) {
        String columnKey = chosenColumns_p[i];  //The current column key
        
        DataItem item = null;           //The eventual DataItem object
        boolean parentsInQuery = false;     //Double-check to add to/keep in query
        if (columnKey.startsWith("@")) {
           //this is an existing data item - format=@II.HH where II is the index value and HH is the hash code in HEX
           String indexStr = null;
           String hexHashStr = null;
           int hashCode = -1;
           int pos = -1;

           pos = columnKey.indexOf('.');
           if (pos > 0 && pos < columnKey.length()) {
          indexStr = columnKey.substring(1, pos);
          hexHashStr = columnKey.substring(pos + 1);
          try {
             hashCode = Integer.parseInt(hexHashStr, 16);

             //search persisted item list for existing data item reference
             DataItemList itemList = m_query.getPersistedItemList();
             for (int j=0; j<itemList.size(); j++) {
            DataItem existingItem = itemList.elementAt(j);
            if (existingItem.hashCode() == hashCode) {
               item = existingItem; //found it - save reference
               parentsInQuery = parentsInList(m_query, item.getExpression(), postProcessTables);
//System.out.println("Existing item("+item.toString()+") - parents in query? " + parentsInQuery); //BKD:DEBUG
               break;       //no need to keep looking
            }
             }
          } catch (NumberFormatException nfe) {
          	System.out.println("exception = " + nfe);
          }
           }
        }

	
	//############## 4/28/04 maperr Code to change the formating #################
	if (item != null && parentsInQuery) {
		int type = getDataType(m_query, item);
		if(type == 16){
			OptionBean ob = OptionBean.getInstance(session);
			String dateFormat = ob.getOption("datefmt");
			if(dateFormat != null){
				item.setFormat(dateFormat);
			}
		}
        }
	
	//############################################################


        //check to see if a valid DataItem object was identified
        if (item != null && parentsInQuery) {
           keepers.addElement(item);
        }
     }

     for (int i=queryItems.size(); i>0; i--) {
        DataItem existingItem = queryItems.elementAt(i-1);
        if (keepers.indexOf(existingItem) < 0) {
           //not a keeper, so remove it
           //remove the item and everything it touches
           existingItem.deleteFromQuery();
           queryItems.removeElementAt(i-1);
        }
     }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
     
     for (int i=0; i<chosenColumns_p.length; i++) {
        String columnKey = chosenColumns_p[i];  //The current column key
        DataItem item = null;           //The eventual DataItem object
        boolean parentsInQuery = false;     //Double-check to add to/keep in query
        boolean newItem = false;            //Flag to tell if new item or not
        if (columnKey.startsWith("@")) {
           //this is an existing data item - format=@II.HH where II is the index value and HH is the hash code in HEX
           String indexStr = null;
           String hexHashStr = null;
           int hashCode = -1;
           int pos = -1;   
  
           pos = columnKey.indexOf('.');
           if (pos > 0 && pos < columnKey.length()) {
          indexStr = columnKey.substring(1, pos);
          hexHashStr = columnKey.substring(pos + 1);
          try {
             hashCode = Integer.parseInt(hexHashStr, 16);

             //search persisted item list for existing data item reference
             DataItemList itemList = m_query.getPersistedItemList();
             for (int j=0; j<itemList.size(); j++) {
            DataItem existingItem = itemList.elementAt(j);
            if (existingItem.hashCode() == hashCode) {
               item = existingItem; //found it - save reference
         
               parentsInQuery = parentsInList(m_query, item.getExpression(), postProcessTables);
//System.out.println("Existing item("+item.toString()+") - parents in query? " + parentsInQuery); //BKD:DEBUG
               break;       //no need to keep looking
            }
             }
          } catch (NumberFormatException nfe) {
          }
           }
        } else {
           //this is a new data item!
           newItem = true;
           //Generate the expression
               Expression expression = ((HRVQuery)m_query).createExpressionInstance(columnKey);
           parentsInQuery = parentsInList(m_query, expression, postProcessTables);
//System.out.println("New item ("+columnKey+") parents in query? " + parentsInQuery);
           if (parentsInQuery) {
          item = new JspDataItem(m_query, expression, true);
          //### Missed a spot #####
	  if (item != null && parentsInQuery) {
		int type = getDataType(m_query, item);
		if(type == 16){
			OptionBean ob = OptionBean.getInstance(session);
			String dateFormat = ob.getOption("datefmt");
			if(dateFormat != null){
				item.setFormat(dateFormat);
			}
		}
          }
          m_query.getPersistedItemList().addElement(item);
          m_query.addResultItem(item.getResultItem());
           } else {
          //not going to add to query, so don't bother with the rest of it...
//            item = new JspDataItem(m_query, expression);
//        ((JspDataItem)item).isInResults(true);
           }
        }

        //check to see if a valid DataItem object was identified
        if (item != null && parentsInQuery) {
//application.log("DataItem found && parents are still in query: " + item.getDisplayString());
           int actualPosition = -1;
           int desiredPosition = -1;
           //If the item has a result item && it is currently in the query results, move it to the
           //appropriate position
           if (((JspDataItem)item).isInResults()) {
          desiredPosition = resultItemCount;
          actualPosition = m_query.getPositionForResultItem( item.getResultItem() );
//application.log("  Adjusting result item position " + actualPosition + " ==> " + desiredPosition);
          if (desiredPosition != actualPosition)
             m_query.moveResultItem( actualPosition, desiredPosition );

          resultItemCount++;
           }
           //move the data item to it's proper place
           desiredPosition = itemCount;
           actualPosition = queryItems.indexOf(item);
//application.log("  Adjusting data item position " + actualPosition + " ==> " + desiredPosition);
           if (desiredPosition != actualPosition) {
          queryItems.removeElementAt(actualPosition);
          queryItems.insertElementAt(item, desiredPosition);
           }
           itemCount++;
        } else {
           //then something bad has happened... :(
           //unrecognized data item, so should report the inability to add data item to query to user.
        }
     }
      }

      //Now figure out what data items need to be removed
//application.log("Truncating items at position: " + (i-1));
      for (int i=queryItems.size(); i>itemCount; i--) {
         DataItem item = queryItems.elementAt(i-1);
     //remove the item and everything it touches
     item.deleteFromQuery();
     queryItems.removeElementAt(i-1);
      }

      ////////////////////////////////////////////////////////////////////////////////
      // PROCESS SELECTED JOIN TYPE
      ////////////////////////////////////////////////////////////////////////////////
      //check to make sure there is a join value to work with
      if (join_p != null && join_p.trim().length() > 0) {
         int joinType = -1; //the join type specified

     //determine what join type from the parameter value
         if ("inner".equalsIgnoreCase(join_p)) {
        joinType = JoinConstants.INNER_JOIN;
     } else if ("left".equalsIgnoreCase(join_p)) {
        joinType = JoinConstants.LEFT_JOIN;
     }

     //if we could determine the join type, then set it on the model
     if (joinType != -1) {
        m_query.setJoinType(joinType);
     }
      }

      firePropertyChanges(m_query); //BKD:TEST
   }
   ////////////////////////////////////////  END PROCESS DATA  ////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// PROCESS ACTION
//
// None and update should have been taken care of by now.
// If action is "goto" and there have been no errors, then we should build the
// URL for the next page and redirect the browser there.
// If action is "goto" and there have been errors, then we should keep the
// user here and have them correct the problem.
////////////////////////////////////////////////////////////////////////////////
if ("goto".equals(action) && !hasError) {
//   application.log("Redirecting to step: " + stepToGoto);//BKD:DEBUG

   //If we are moving to the 'edit sql' step, then we need to set the returnTo
   //parameter so it will send us back to the right place.
   if ("editsql".equals(stepToGoto))
      riders.put("returnTo", request.getAttribute("topic"));

   String nextURL = getRedirectURL(bundle, stepToGoto, riders);

   //send URL redirect to browser and stop processing
   response.sendRedirect(response.encodeRedirectURL(nextURL));
   return;
}

////////////////////////////////////////////////////////////////////////////////
// DISPLAY STEP VIEW
//
// If the query model contains more tables than is allowed in the join limit,
// then we should forward the user to the advanced view.  Otherwise, we should
// build the beans for the simple view and forward the user there.
////////////////////////////////////////////////////////////////////////////////
//application.log("Getting view for step 1 ready...");//BKD:DEBUG

   //Check to see if this query is too complex for this visual
   Integer joinLimit = (Integer)request.getAttribute("joinLimit");
   if (m_query.getTableCount() > joinLimit.intValue()) {
      //This query should be shown with the advanced view.
      riders.put("returnTo", request.getAttribute("topic"));
      riders.put("adv", "y");
      String nextURL = getRedirectURL(bundle, "editsql", riders);

      //send URL redirect to browser and stop processing
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   } else {
      //This query is simple enough to be shown with the simple view.
      //We need to construct the Transformation Beans used in the simple view.
      //These beans include:
      //    The library radio buttons
      //    The available/selected tables lists
      //    The available/selected columns lists
      //    The join type radio buttons
      Radio librarySelector = null;     //The library selector bean
     StringCollection librarySelectorDescModel = null;  //The descriptive library names
      SelectorCtrl tableSelector = null;    //The available/selected table(s) selector bean
     String m_availableTablesLabel = null;  //The label for the available tables list
     String m_selectedTablesLabel = null;   //The label for the selected tables list
     NamedList availableTablesList = null;  //The list of available tables
     NamedList selectedTablesList = null;   //The list of selected tables
      SelectorCtrl columnSelector = null;   //The available/selected column(s) selector bean
     String m_availableColumnsLabel = null; //The label for the available columns list
     String m_selectedColumnsLabel = null;  //The label for the selected columns list
     NamedList availableColumnsList = null; //The list of available columns
     NamedList selectedColumnsList = null;  //The list of selected columns

      //Construct the library selector radio buttons
      librarySelector = new Radio();
      librarySelector.setName("library");       //form item name = "library"
      librarySelector.setBreak(false);          //for aesthetic purposes
      librarySelector.setCustomAttributes(librarySelectorCustomAttributes); //custom action
      librarySelector.setModelInterface(librarySelectorModel);          //set the value model
     //the description model for library choices (locale specific)
     librarySelectorDescModel = new StringCollection();
     librarySelectorDescModel.add(bundle.getString("ColumnSelector.PublicTablesLabel.txt"));
     librarySelectorDescModel.add(bundle.getString("ColumnSelector.PrivateTablesLabel.txt"));
      librarySelector.setDescriptionModel(librarySelectorDescModel);    //set the descriptive model
      //set the current library choice
      if (location == MetaBean.PUBLIC_LOC)
         librarySelector.setSelectedIndex(0);               //select public library
      else
         librarySelector.setSelectedIndex(1);               //select private library
      request.setAttribute("librarySelector", librarySelector);     //add the selector to the request

      //construct the join type selector
      Radio joinSelector = null;        //The join selector bean
     StringCollection joinSelectorDescModel = null; //The descriptive join labels
      joinSelector = new Radio();
      joinSelector.setName("join");     //form item name = "join"
//      joinSelector.setBreak(false);       //for aesthetic purposes
      joinSelector.setModelInterface(joinSelectorModel);            //set the value model
     //the description model for join choices (locale specific)
     joinSelectorDescModel = new StringCollection();
     joinSelectorDescModel.add(bundle.getString("ColumnSelector.JoinType.Inner.txt"));
     joinSelectorDescModel.add(bundle.getString("ColumnSelector.JoinType.Left.txt"));
      joinSelector.setDescriptionModel(joinSelectorDescModel);  //set the descriptive model
      //set the current join choice
      switch (m_query.getJoinType()) {
         case JoinConstants.INNER_JOIN:
        joinSelector.setSelectedIndex(0);       //select inner join
        break;
     case JoinConstants.LEFT_JOIN:
        joinSelector.setSelectedIndex(1);       //select left join
        break;
     default:
        //this would be an error state at this point...
      }

      request.setAttribute("joinSelector", joinSelector);       //add the selector to the request

      Checkbox labelSelector = new Checkbox();
      labelSelector.setName("label");
      labelSelector.setLabel(bundle.getString("ColumnSelector.ShowLabelsButton.txt"));
      labelSelector.setValue("Y");
      labelSelector.setSelected(m_query.isShowLabels());
      labelSelector.setCustomAttributes(labelSelectorCustomAttributes); //custom action
      request.setAttribute("labelSelector", labelSelector);     //add the selector to the request



      //#### maperr 5/5/04 Adding a choicbox for underlying user prompts ####
      Checkbox promptSelector = new Checkbox();
      promptSelector.setName("prompt");
      promptSelector.setLabel(bundle.getString("ColumnSelector.RefreshPromptButton.txt"));
      promptSelector.setValue("Y");
      TableBean tb = m_query.getWorkingTableBean();
      String usePrompt = tb.getAttributeValue("useprompt");
      if(usePrompt != null && usePrompt.equals("true"))
          promptSelector.setSelected(true);
      request.setAttribute("promptSelector", promptSelector);     //add the selector to the request
      //####################################################################

      //Construct the available/selected tables list
      //    The available list comes from the current library
      //    The selected list comes from the model

      //***build the list of available tables based on currently selected library
    availableTablesList = new NamedList();
    TableBean tableBean = new TableBean(session);
    String libLabel;
    if (location == MetaBean.PUBLIC_LOC)
    {
        tableBean.setMetaLocation(MetaBean.PUBLIC_LOC);
        libLabel = MetaBean.PUBLIC_DATA_LIBREF;
    }
    else
    {
        tableBean.setMetaLocation(MetaBean.PRIVATE_LOC);
        libLabel = MetaBean.PRIVATE_DATA_LIBREF;
    }
    for (Iterator itor = tableBean.getItems().iterator(); itor.hasNext();)
    {
        tableBean.setMetaKey((String)itor.next());
        // ignore mddbs
        if ("MDDB".equalsIgnoreCase(tableBean.getAttributeValue("tbltype")))
            continue;
        String name = libLabel + "." + tableBean.getMetaKey();
        String value = tableBean.getAttributeValue("desc");
        if (m_query.isShowLabels())
        {
            if (value != null)
               value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", libLabel, value);
            else
               value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", libLabel, name);     //matches explorer list order but has formatted table entry
        }
        availableTablesList.add(name, value);
    }
    availableTablesList.sortByAscendingValue(false);
//****************************** 
//    changed here
//      DataSourceContainerList availableTables = null;   //List of tables
//      if (location == MetaBean.PUBLIC_LOC)
//         availableTables = m_dataSource.getItems().elementAt(0).getItems();
//      else
//         availableTables = m_dataSource.getItems().elementAt(1).getItems();
//
//      availableTablesList = new NamedList();
//      for (int i=0; i<availableTables.size(); i++) {
//         HRVDataSourceTable table = (HRVDataSourceTable)availableTables.elementAt(i);
//     String name = table.getQualifiedName();    //Qualified name
//     String value = table.getDescription();     //Description
//
//     if (m_query.isShowLabels()) {
//        if (value != null)
//           value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", table.getParent().getName(), value);
//        else
//           value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", table.getParent().getName(), table.getName());     //matches explorer list order but has formatted table entry
////         value = name;        //matches explorer list order but has plain table entry
//     } else
//        value = name;
//
//     availableTablesList.add(name, value);
//      }
//*********************************/

      //***build the list of selected tables based on the query model
      selectedTablesList = new NamedList();
      TableList tablesInModel = m_query.getTables();
      for (int i=0; i<tablesInModel.size(); i++) {
         Table tableInModel = tablesInModel.elementAt(i);
     HRVDataSourceTable table = (HRVDataSourceTable)tableInModel.getDataSourceTable();
     String name = "@"+i+"."+Integer.toHexString(tableInModel.hashCode());
     String value = table.getDescription();     //Description

     if (m_query.isShowLabels()) {
        if (value != null)
           value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", table.getParent().getName(), value);
        else
           value = bundle.getSentenceParameters("ColumnSelector.TableListEntry.fmt.txt", table.getParent().getName(), table.getName());
//         value = table.getQualifiedName();
     } else
        value = table.getQualifiedName();

     selectedTablesList.add(name, value);
      }

      tableSelector = new SelectorCtrl(session);
      tableSelector.setFormName( "initQry" );               //the name of the parent form
      tableSelector.setFormTagEnabled( false );             //do not write the form tag
      tableSelector.setJavaScriptEnabled( true );           //write out the javascript
      tableSelector.setSourceName( "tables" );              //source list name
      tableSelector.setTargetName( "tableKeys" );           //target list name
      tableSelector.setMaxTargetItems(joinLimit.intValue());        //set join limit
      tableSelector.setSourceUpdateEnabled( false );            //leave the table in the list
      tableSelector.setTargetDuplicatesEnabled( false );        //but only 1 instance per table
     m_availableTablesLabel = bundle.getString("ColumnSelector.AvailableTablesLabel.txt");
     m_selectedTablesLabel = bundle.getString("ColumnSelector.SelectedTablesLabel.txt");
      tableSelector.setSourceHeader( m_availableTablesLabel );      //set the available tables header
      tableSelector.setTargetHeader( m_selectedTablesLabel );       //set the selected tables header
      tableSelector.setSourcePostTrigger("doNav('update')");        //update when changed
      tableSelector.setTargetPostTrigger("doNav('update')");        //update when changed
      tableSelector.alphabetizeSource( false );             //alphabetize the source list
      tableSelector.alphabetizeTarget( false );             //leave the target list as is
      tableSelector.setSourceList( availableTablesList );       //List of available tables
      tableSelector.setTargetList( selectedTablesList );        //List of selected tables
      tableSelector.setMoveAllEnabled(false);               //Do not allow move all
      request.setAttribute("tableSelector", tableSelector);     //add the selector to the request

      //Construct the available/selected columns list
      //    The available list comes from the tables in the model
      //    The selected list comes from the data items in the model

      //***build the list of available columns based on the currently selected tables
      //    we need to create an alphabetized list of columns for each table and present them in the
      //    order they appear in the selected table list.
      availableColumnsList = new NamedList();
      for (int i=0; i<tablesInModel.size(); i++) {
         Table tableInModel = tablesInModel.elementAt(i);
     HRVDataSourceTable table = (HRVDataSourceTable)tableInModel.getDataSourceTable();

     //for each table in the model, we need to get the list of columns
     DataSourceColumnList colList = table.getColumns();
     NamedList tempColumnList = new NamedList();
     for (int j=0; j<colList.size(); j++) {
        HRVDataSourceColumn column = (HRVDataSourceColumn)colList.elementAt(j);
        String name = tableInModel.getDisplayName() + "." + column.getName();
        String value = column.getDescription();     //Description

        if (m_query.isShowLabels()) {
           if (value != null)
          value = bundle.getSentenceParameters("ColumnSelector.ColumnListEntry.fmt.txt", table.getParent().getName(), tableInModel.getDisplayName(), value, table.getDescription());
           else
          value = bundle.getSentenceParameters("ColumnSelector.ColumnListEntry.fmt.txt", table.getParent().getName(), tableInModel.getDisplayName(), column.getName(), table.getDescription());
        } else
           value = messageFormat(bundle, "ColumnSelector.ColumnListEntry.NoLabels.fmt.txt", table.getParent().getName(), tableInModel.getDisplayName(), column.getName(), table.getDescription(), column.getName());
        
        tempColumnList.add(name, value);
     }
     tempColumnList.sortByAscendingValue( false );
     for (int j=0; j<tempColumnList.size(); j++) {
        availableColumnsList.add(tempColumnList.getName(j), tempColumnList.getValue(j));
     }
      }


      //***build the list of selected columns based on the query model
      selectedColumnsList = new NamedList();
      DataItemList itemsInModel = ((HRVQuery)m_query).getPersistedItemList();
      for (int i=0; i<itemsInModel.size(); i++) {
         JspDataItem item = (JspDataItem)itemsInModel.elementAt(i);
     Expression expression = item.getExpression();
     String name = "@"+i+"."+Integer.toHexString(item.hashCode());
     String value = null;

     if (m_query.isShowLabels()) {
        value = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
     } else {
        value = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.NoLabels.fmt.txt");
     }

     selectedColumnsList.add(name, value);
      }

      columnSelector = new SelectorCtrl(session);
      columnSelector.setFormName( "initQry" );              //the name of the parent form
      columnSelector.setFormTagEnabled( false );            //do not write the form tag
      columnSelector.setJavaScriptEnabled( false );         //do not write the javascript
      columnSelector.enableTargetOrdering( true );          //need to be able to order columns
      columnSelector.setSourceName( "columns" );            //source list name
      columnSelector.setTargetName( "columnKeys" );         //target list name
     m_availableColumnsLabel = bundle.getString("ColumnSelector.AvailableColumnsLabel.txt");
     m_selectedColumnsLabel = bundle.getString("ColumnSelector.SelectedColumnsLabel.txt");
      columnSelector.setSourceHeader( m_availableColumnsLabel );    //set the available tables header
      columnSelector.setTargetHeader( m_selectedColumnsLabel );     //set the selected tables header
      columnSelector.setSourceUpdateEnabled( false );           //do not allow changes to source
      columnSelector.setTargetDuplicatesEnabled( true );        //multiple instances allowed
      columnSelector.alphabetizeSource( false );            //*I* will order the source list
      columnSelector.alphabetizeTarget( false );            //leave the target list as is
      columnSelector.setSourceList( availableColumnsList );     //List of available columns
      columnSelector.setTargetList( selectedColumnsList );      //List of selected columns
      request.setAttribute("columnSelector", columnSelector);       //add the selector to the request
   }

   //forward the request to the view page
   pageContext.forward((String)request.getAttribute("viewURL"));
%>
<%!
   public boolean contains(TableList list, Table table)
   {
      for (int i=0; i<list.size(); i++) {
         if (list.elementAt(i) == table) {
        return true;
     }
      }

      return false;
   }

   public boolean parentsInList(HRVQuery query, Expression expression, TableList tables)
   {
      if (expression instanceof ConstantExpression) {
         return true;               //Constant expressions shouldn't rely on tables...
      } else {
////////////////////////////////////////////////////////////////////////////////
//System.out.println("Expression ("+expression.generateSQL(query.getSqlLogic(), Expression.EXP_GEN_DECLARATION) + ") is " + expression.getClass().getName()); //BKD:DEBUG
////////////////////////////////////////////////////////////////////////////////

     ExpressionList allExps = query.getExpressionList(expression);
     ExpressionList unparsedExps = ((HRVDataSource)query.getDataSource()).getExpressionsByClass(allExps, UnparsedExpression.class);

     for (int i=0; i<unparsedExps.size(); i++) {
        Expression subExp = unparsedExps.elementAt(i);
        String value = subExp.toString();
//System.out.println("  Unparsed sub-expression: " + value); //BKD:DEBUG
        if (value.length() > 0) {
           if (Character.isLetter(value.charAt(0))) {
           ResultItem item = findResultItem(query, (UnparsedExpression)subExp);
           //1st char is a letter - not a text constant because that would be
           //quoted.  not a macro var because that would start with &.  not a
           //numeric constant because that would be [\-+.0-9].  probably invalid
           //unless it is an unrecognized reference to a result item alias
           if (item == null)
          return false;
        }
        }
     }

////////////////////////////////////////////////////////////////////////////////
     ExpressionList colExps = ((HRVDataSource)query.getDataSource()).getExpressionsByClass(allExps, ColumnExpression.class);
     for (int j=0; j<colExps.size(); j++) {
        ColumnExpression ce = (ColumnExpression)colExps.elementAt(j);
        Table table = ce.getColumn().getParent();
        if (!contains(tables, table)) {
//System.out.println("FAIL: Expression refers to table ("+table.getName() + ") which is not in the query!"); //BKD:DEBUG
           return false;
        }
     }
////////////////////////////////////////////////////////////////////////////////
      }
      return true;
   }

   public ResultItem findResultItem(HRVQuery query, UnparsedExpression expToFind)
   {
      ResultItem item = null;

      ResultItemList items = query.getResultItems();
      for (int i=0; i<items.size(); i++) {
         ResultItem ri = items.elementAt(i);
     if (expToFind.toString().equalsIgnoreCase(ri.getAlias())) {
        item = ri;
        break;
     }
      }

      return item;
   }
%>
