<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%!
   static String VIEW_NAME = "work.queryView";
   static String LAST_VIEW_NUM = "lastQueryViewIndex";
%>
<%
   VisMsg bundle = (VisMsg)request.getAttribute("resources");
   HashMap riders = new HashMap();
   riders.put("sessionkey", m_sessionKey);
   riders.put("prompted", request.getParameter("prompted"));
   riders.put("run", request.getParameter("run"));

//System.out.println("m_query = " + m_query);

   //Check to see if there are any result items yet
   if (m_query.getResultItemCount() == 0) {
      riders.put("msg", "NoResultItems.txt");
      String nextURL = getRedirectURL(bundle, "display", riders);

      //send URL redirect to browser and stop processing
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   }

   TableBean workingBean = m_query.getWorkingTableBean();

   //an interface to the physical data
   com.sas.sasserver.dataset.DataSetInterface dsI = null;

String dummyStuff = workingBean.getAttributeValue("useprompt");
if(dummyStuff == null)
    dummyStuff = "false";

if (m_query.getNeedsRefresh()) {

   //Check to see if there are any invalid columns in the query
   //  This can happen when a table needs to be refreshed by HR Vision
   ColumnList invalidColumns = new ColumnList();	//the list of bad columns
   TableList tablesInModel = m_query.getTables();	//the list of tables in the model
   //make sure we have an actual interface
   dsI = getDataSetInterface(session);
   if (dsI != null) {
      //step through the tables in the model.
      for (int i=0; i<tablesInModel.size(); i++) {
	 com.sas.query.models.Table table = tablesInModel.elementAt(i);
	 HRVDataSourceTable hrvDST = (HRVDataSourceTable)table.getDataSourceTable();
	 try {
	    //open the view for browsing


	    dsI.setDataSet(hrvDST.convertToView());

	    //get our set of columns
	    ColumnList columnsInTable = table.getColumns();
	    //check each column for its presence in model and in dataset
	    for (int j=0; j<columnsInTable.size(); j++) {
	       Column column = columnsInTable.elementAt(j);
	       if (m_query.isColumnInQuery(m_query, column)) {
		  //check for validity
		  try {
		     int colIndex = dsI.getColumnIndex(column.getName());
		  } catch (IllegalArgumentException e2) {
		     //bad column
		     invalidColumns.addElement(column);
		  }
	       }
	    }
	 } catch (IllegalArgumentException e) {
	    //table not in database
	 } catch (com.sas.table.TableException e) {
	    //remote interface related error
	 } finally {
	    dsI.setDataSet(null);
	 }
      }
      dsI.setDataSet(null);
      dsI.close();		//we're finished w/ the dataset interface
   } else {
      //what now?
      //no validity check, that's for sure!
   }
   if (invalidColumns.size() > 0 && dummyStuff.equals("false")) {
      //found 1 or more columns that were invalid - halting execution of query
      StringBuffer errMsg = new StringBuffer();
      for (int i=0; i<invalidColumns.size(); i++) {
	 Column column = invalidColumns.elementAt(i);
	 HRVDataSourceTable hrvDST = (HRVDataSourceTable)column.getParent().getDataSourceTable();
      	 errMsg.append(hrvDST.getQualifiedName()+"."+column.getName()+"\n");
      }

      request.setAttribute("error.title", "Results.Message.InvalidColumns.txt");
      request.setAttribute("error.message", errMsg.toString());

      //forward request to error page and stop processing
      pageContext.forward((String)request.getAttribute("errURL"));
      return;
   }
}

   //Check for specified output name
   String viewName = request.getParameter("name");
   if (viewName == null) {	//If none given
/*
      viewName = VIEW_NAME;	// then use default

      int lVNI = 0;		//A sequential number to put at the end of the
				   //  view name.
      //If persistent value found, then increment and store
      String lastViewNameIndex = (String)hrvi.getSessionValue(session, LAST_VIEW_NUM);
      if (lastViewNameIndex != null) {
	 lVNI = Integer.parseInt(lastViewNameIndex);	//Get value
	 lVNI++;					//Increase by 1
      }
      //Store value for future use
      hrvi.setSessionValue(session, LAST_VIEW_NUM, (Object)String.valueOf(lVNI));

      //Alter name accordingly
//      viewName = viewName + lVNI;	//Not needed yet... 29MAR2001
*/
      viewName = "work.q"+workingBean.getMetaKey();
   }
   request.setAttribute("viewname", viewName);

//BKD:FIX - Need to check for prompts and if any are present, then send to
//Casey's prompter here before we run the statement.
//  EX: "../Jsp/userPrompt.jsp?command=RUN&table="+<TableBean in session>+"&returnUrl=../Query/Step4.jsp?sessionkey="+m_sessionKey+"&prompted=y"

   if (!"y".equals(request.getParameter("prompted"))) {
      //if there are any expressions that are ParameterExpressions, then we
      //need to send them to the prompter



      if (hasUserPrompt(m_query) || dummyStuff.equals("true")) {
      	 m_query.setNeedsRefresh(true);	//always refresh for now with prompts
//BKD:NOTE - will this code munge values that are from an existing query being
//edited?  Ones that should be maintained instead?
	 m_dataSource.updateTableBean(workingBean, m_query);
	 TableCtrl hrvTable = (TableCtrl) hrvi.getSessionValue(session, "TABLE_" + viewName);
	 if(hrvTable != null)
	 	hrvTable.closeDS();

	 workingBean.write();

	 String sessionLoc = "QTABLE_"+viewName;
	 session.setAttribute(sessionLoc, workingBean);
	 String returnUrl = "../Query/Step4.jsp?sessionkey="+m_sessionKey+"&prompted=y";
	 session.setAttribute("returnURL", returnUrl);
	 String sendTo = "../Jsp/userPrompt.jsp?command=RUN&table="+sessionLoc+"&sessionkey="+m_sessionKey+"&returnUrl=" + returnUrl;
	 response.sendRedirect(response.encodeRedirectURL(sendTo));
	 return;
      }
   }

   m_messages.removeAllMessages();
   if (true) {
      HRVSqlLogic logic = (HRVSqlLogic)m_query.getSqlLogic();
      logic.setMasking(true);			//Apply masking
      String strQuery = logic.genQuery( m_query );	//Get the SQL command
      logic.setMasking(false);			//Disable masking

      StringBuffer submitBuffer = new StringBuffer();

      //May not need to drop an existing view by that name, but it should not
      //  hurt us...
      submitBuffer.append("proc sql;");
      submitBuffer.append("DROP VIEW " + viewName + ";");
      submitBuffer.append("CREATE VIEW " + viewName + " AS " + strQuery + ";");
      submitBuffer.append("quit;");
//      System.out.println("SubmitBuffer:");	//BKD:DEBUG
//      System.out.println(submitBuffer.toString());	//BKD:DEBUG
   }
   //if (m_query.isValidSql()) {
   if(true){
if (m_query.getNeedsRefresh()) {
      //Grab the HRVSqlLogic used by the query to generate the SQL command
      HRVSqlLogic logic = (HRVSqlLogic)m_query.getSqlLogic();
      logic.setMasking(true);			//Apply masking
      String strQuery = logic.genQuery( m_query );	//Get the SQL command

      //###############maperr 2/17/2004##################
      strQuery = m_dataSource.getModifiedSql(strQuery, m_query, true);
      //###############maperr 2/17/2004##################
      //### This places the table key on the user prompt ###
      String tableKey = "&" + workingBean.getMetaKey() + "_";


      //MAPERR DEFECT S0291353
      boolean inQuote = false;
      for(int i = 0; i < strQuery.length(); i++){
      	String letter = strQuery.substring(i, i + 1);

      	if(letter.equals("'") && !inQuote)//starting a quote
      		inQuote = true;
      	else if(letter.equals("'") && inQuote)//ending a quote
      		inQuote = false;

		if(letter.equals("&") && !inQuote){
			strQuery = strQuery.substring(0, i) + tableKey + strQuery.substring(i + 1);
		}
      }

      //### This places 1=1 around ALL selects for user prompts ###
      strQuery = m_dataSource.replaceSelectAll(strQuery, workingBean);

      logic.setMasking(false);			//Disable masking

      //Get the connection to the data source
      ConnectionInterface cI = ConnectionInterface.getInstance(session);
      StringBuffer submitBuffer = new StringBuffer();

      //May not need to drop an existing view by that name, but it should not
      //  hurt us...
      submitBuffer.append("proc sql;");
      submitBuffer.append("DROP VIEW " + viewName + ";");
      submitBuffer.append("CREATE VIEW " + viewName + " AS " + strQuery + ";");

      //### need to add order and group by code here ###

      //System.out.println("submitting step4.jsp");
      submitBuffer.append("quit;");

      cI.submit(submitBuffer.toString());	//Submit the sas commands
////////////////////////////////////////////////////////////////////////////////
// Check to make sure the results are there...
////////////////////////////////////////////////////////////////////////////////
      //lets check the results...

      //make sure we have an instance
      if (dsI == null)
	 dsI = getDataSetInterface(session);

      //double check to make sure that worked!
      if (dsI != null) {
	 try {
	    dsI.setDataSet(viewName);
	 } catch (IllegalArgumentException iae) {
	    //dataset does not exist!!
	    dsI.setDataSet(null);
	    dsI.close();

	    request.setAttribute("error.title", "Results.Message.GeneralExecutionError.txt");
	    //use exception message?  or resource bundle message?
//	    request.setAttribute("error.message", iae.getMessage());
	    request.setAttribute("error.message", bundle.getString("Results.Message.ResultsNotAvailable.txt"));

	    //forward request to error page and stop processing
	    pageContext.forward((String)request.getAttribute("errURL"));
	    return;
	 }
	 dsI.setDataSet(null);
	 dsI.close();
      }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
}

      //Remove any previous view controls
      hrvi.removeSessionValue(session, "TABLE_" + viewName);

      TableCtrl hrvTable = new TableCtrl(session);
      hrvi.setSessionValue(session, "TABLE_" + viewName, hrvTable);
      hrvi.setSessionValue(session, "REMOVE_VIEW", "TABLE_" + viewName);
      String tableTitle = workingBean.getAttributeValue("desc");
      if (tableTitle == null || tableTitle.trim().length() == 0)
      	 tableTitle = bundle.getString("Results.DefaultTitle.txt");
      hrvTable.setTableDescription(tableTitle);
// set up the number of rows to display....
			OptionBean opt = OptionBean.getInstance(session);
			String num = opt.getOption("table_rows");
			int rows = 10;
			if (num != null)
				if (!num.equals(""))
					rows = Integer.parseInt(num);
			hrvTable.setMaxRows(rows);
			// set the data set/view on the table bean.
			hrvTable.setView(viewName);
			// set vars to be passed along.
			hrvTable.setPerpetuateVar("CURRENTVIEW");
			hrvTable.setPerpetuateVar("style");
			hrvTable.setPerpetuateVar("ctrlButtons");
			// set up the link variable.
		        hrvTable.setLink("ID", "../Jsp/empprofile.jsp", "empprofile");

      //Send user to table viewer on newly created view
      String forwardUrl = (String)request.getAttribute("viewURL");
      Object[] args = { viewName };

      m_query.setNeedsRefresh(false);		//we've refreshed the results
      forwardUrl = java.text.MessageFormat.format(forwardUrl, args);
//System.out.println("forwardUrl: " + forwardUrl);	//BKD:DEBUG
//      pageContext.forward(forwardUrl);
      response.sendRedirect(response.encodeRedirectURL(forwardUrl));
      return;
   } else {
      request.setAttribute("error.title", "Results.Message.InvalidSyntax.txt");
      request.setAttribute("error.message", m_messages.getOneBigMessage());
      m_messages.removeAllMessages();
      pageContext.forward((String)request.getAttribute("errURL"));
   }

   /*
   //Send to link
   //  onClick="newWin=open('../Jsp/newWindow.jsp?../Jsp/exportTable.jsp?key=[KEY]&type=[TYPE]&location=[LOCATION]', 'HrvScratchWindow', 'height=1 width=1 alwaysLowered');"
   //Where
   //  key	= the meta key of the table bean
   //  type	= the type of item (ex: Table)
   //  location	= the meta location of the table bean
   //
   */
%>
<%!

public com.sas.sasserver.dataset.DataSetInterface getDataSetInterface(HttpSession session)
{
   com.sas.sasserver.dataset.DataSetInterface dsI = null;
   try {
      ConnectionInterface cI = ConnectionInterface.getInstance(session);
      com.sas.rmi.Rocf rocf = cI.getRocf();
      com.sas.rmi.Connection con = cI.getCon();

      dsI = (com.sas.sasserver.dataset.DataSetInterface)rocf.newInstance(com.sas.sasserver.dataset.DataSetInterface.class, con);
   } catch (Exception e) {
      //what now?
   }

   return dsI;
}
%>
