<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.rmi.Rocf" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ page import="com.sas.sasserver.dataset.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.text.*" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%!
// ### ADDITIONS FOR COLUMN SELECTION
	public String COLUMN_PREFIX = HRVParser.COLUMN_PREFIX;
// ### DONE WITH ADDITIONS

   static String TYPE_ACTUAL = "A";
   static String TYPE_POSSIBLE = "P";
   static String TYPE_USER = "U";
// ### ADDITIONS FOR COLUMN SELECTION
   static String TYPE_COLUMN = "C";
// ### DONE WITH ADDITIONS

%>
<%
   //get the resource bundle
   VisMsg bundle = (VisMsg)request.getAttribute("resources");
   request.setAttribute("error.msg", "");   //no error message by default

   //get the type value from the form (if any)
   String typeString = request.getParameter("type");

   //SETUP the item number string - This parameter determines which row from
   //the form in the parent (filters) window to both apply the selected
   //value(s) to and to monitor the currently selected column from.
   String itemNumStr = request.getParameter("item");
   if (itemNumStr == null || itemNumStr.trim().length() == 0)
      itemNumStr = "0";
   Integer itemNum = null;
   try {
      itemNum = Integer.valueOf(itemNumStr);
   } catch (NumberFormatException nfe) {
      itemNum = new Integer(0);
   }
   if (itemNum.intValue() < 0) {
      itemNum = new Integer(0);
   }

   //save these values for later - just in case
   request.setAttribute("itemNumStr", itemNum.toString());
   request.setAttribute("itemNum", itemNum);

   //Get the list of persisted items
   DataItemList m_itemList = m_query.getPersistedItemList();

   //SETUP the result item string value
   String columnStr = request.getParameter("column");
   if (columnStr == null) {
      //if no columns specified, then just grab the first one
      JspDataItem dataItem = (JspDataItem)m_itemList.elementAt(0);
      //all JspDataItems here will have a result item
      ResultItem item = dataItem.getResultItem();
      columnStr = "0." + item.getDisplayString();
   }

   //Column value is to be selected for
   Hidden columnBean = new Hidden();
   columnBean.setName("column");
   columnBean.setText(columnStr);
   request.setAttribute("columnBean", columnBean);

   //Which type of value is being determined (actual/possible/user prompt)

   StringCollection typeDescModel = new StringCollection();
   StringCollection typeModel = new StringCollection();

   typeModel.add(TYPE_ACTUAL);
   typeDescModel.add(bundle.getString( "Values.ActualValuesButton.txt" ));
   typeModel.add(TYPE_POSSIBLE);
   typeDescModel.add(bundle.getString( "Values.PossibleValuesButton.txt" ));
   if (m_usageMode == USAGE_ALL) {
      typeModel.add(TYPE_USER);
      typeDescModel.add(bundle.getString( "Values.ParametersButton.txt" ));
   }
// ### ADDITIONS FOR COLUMN SELECTION
   typeModel.add(TYPE_COLUMN);
   typeDescModel.add(bundle.getString( "Values.SelectColumnsButton.txt" ));
// ### DONE WITH ADDITIONS

   Radio typeBean = new Radio();
   typeBean.setName("type");
   typeBean.setCustomAttributes("OnClick=\"GetValues()\"");
   typeBean.setModelInterface(typeModel);
   typeBean.setDescriptionModel(typeDescModel);
   if (typeString != null && typeModel.contains(typeString)) {
      typeBean.setSelectedItem(typeString);
   }
   request.setAttribute("typeBean", typeBean);

   //Process the values request
   if (typeString != null) {
      request.setAttribute("typeValue", typeString);
	
      //typeString should be 'A', 'P', or 'U'
	// ### ADDITIONS FOR COLUMN SELECTION
	// or 'C'      
	// ### DONE WITH ADDITIONS

      Listbox valuesBean = new Listbox();
      valuesBean.setName("values");
      valuesBean.setSize(7);

      JspDataItem dataItem = null;
      ColumnExpression expression = null;
      ParenExpression parenExpression = null;
      
      int pos = columnStr.indexOf(".");
      String index_s = columnStr.substring(0, pos);
      try {
         dataItem = (JspDataItem)m_itemList.elementAt(Integer.parseInt(index_s));
      } 
      catch(NumberFormatException nfe) {
        //shouldn't happen...
      }

      if (dataItem != null && dataItem.getSafeExpression() instanceof ColumnExpression) {
        expression = (ColumnExpression)dataItem.getSafeExpression();
      } 
      else
        parenExpression = (ParenExpression)dataItem.getSafeExpression (); 

      if (expression == null && !TYPE_USER.equalsIgnoreCase (typeString)) {
         request.setAttribute("error.msg", bundle.getString("Values.Message.NotForCalcColumns.txt"));
      } 
      else {
         if (TYPE_ACTUAL.equalsIgnoreCase(typeString)) {
            long startTime = System.currentTimeMillis();
//System.out.println("\n");            
 
            if (expression.supportsDistinctValues()) {
               StringCollection model = new StringCollection();
               StringCollection desc_model = new StringCollection();

               Column column = expression.getColumn();
               HRVDataSourceColumn hrvDSC = (HRVDataSourceColumn)m_dataSource.getDataSourceColumn(column);
               if (isValid(session, (HRVDataSourceTable)hrvDSC.getParent(), column.getName())) {

                  NamedList vals = new NamedList(true);
                  HRVDataSourceTable hrvDST = (HRVDataSourceTable)hrvDSC.getParent();
                  String safeTableName = hrvDST.convertToView();
                  String rawFmt = column.getFormat();
                  String outFmt = column.getFormat().toUpperCase();
                  int hrvDSCDataType = hrvDSC.getDataType();

                  //check data type to see if we should get a specific format
                  switch (hrvDSC.getDataType()) {
                     case Expression.EXP_TYPE_CHARACTER:
                     case Expression.EXP_TYPE_NUMERIC:
                     break;
                     case Expression.EXP_TYPE_DATE:
                        // ###Using the configured data format ###
                        OptionBean oB = OptionBean.getInstance(session);
                        outFmt = oB.getOption("datefmt"); //"DATE9.";
                     break;
                     case Expression.EXP_TYPE_TIME:
                        outFmt = "TIME10.";
                     break;
                     case Expression.EXP_TYPE_TIMESTAMP:
                        outFmt = "DATETIME20.";
                     break;
                  }

                  // for some numeric columns that have a format, only the formatted values should be shown, not both
                  boolean showBoth=true;
                  if (hrvDSCDataType == Expression.EXP_TYPE_NUMERIC) {
                     if ( outFmt.indexOf("BEST") != -1 || outFmt.indexOf("DOLLAR") != -1 || outFmt.indexOf("COMMA") != -1  || outFmt.indexOf("SSN")!= -1) {
                        showBoth=false;
                     }
                     // now see if this is a plain numeric format of the type w.d
                     else {
                        try {
                           Double.parseDouble(outFmt);
                           showBoth=false;
                        }
                        catch (java.lang.NumberFormatException e) {}
                     }
                  }
   
                  // The use of the selectClause StringBuffer is new as of 27Feb04.  We need to isolate the select clause
                  // from the rest of the SQL.  The new JDBC connection is used for numeric and character fields.  
                  //The original entire SQL is used for all othe column types.  
                  StringBuffer selectClause = new StringBuffer();
                  selectClause.append("SELECT DISTINCT " + column.getName());
                  selectClause.append(", put(").append(column.getName());
                  selectClause.append(",");
                  selectClause.append(outFmt);
                  selectClause.append(") ");
                  selectClause.append(" AS typeFmt");
                  selectClause.append(" FROM ").append(safeTableName);
                  selectClause.append(" ORDER BY ").append(column.getName());
//System.out.println("selectClause: " + selectClause);   

                  ConnectionInterface cI = ConnectionInterface.getInstance(session);

                  // these will hold the formatted and unformatted values from the result set
                  String formatted = null;
                  Object unformatted = null;

                  // rowcount should have the # of rows from the temp data set or the JDBC result set
                  int rowCount;
          
                  // this is new code that creates a JDBC result set for the unique values
                  // This code is executed only under limited conditions, otherwise the original code runs
                  if (Expression.EXP_TYPE_CHARACTER == hrvDSCDataType || Expression.EXP_TYPE_NUMERIC == hrvDSCDataType) {

                     // get a jdbc connection to read the results set
                     com.sas.iom.SAS.IWorkspace ws = cI.getWorkspace();
                     Properties jdbcProperties = new Properties();
                     com.sas.rio.MVAConnection connection = new com.sas.rio.MVAConnection(ws.DataService(), jdbcProperties);
                     Statement statement = connection.createStatement();
                     ResultSet rs = statement.executeQuery(selectClause.toString());
             
                     // read the result set into the vals namedlist
                     while(rs.next()) {
                        unformatted = rs.getString(1);
                        formatted = rs.getString(2);

                        // make sure missing values display correctly.
                        if (unformatted == null || unformatted instanceof com.sas.MissingValues) {
                           unformatted = "";
                        } 

                        // for values with a format, show both values, except those showBoth is false 
                        if (!formatted.trim().equals(unformatted.toString().trim()) && showBoth) {
                           formatted = formatted.trim() + " (" + unformatted.toString()+")";
                        }

                        // put the final strings into vals for later display in the selection list
                        vals.add(unformatted.toString(), formatted);
                     }
                     rowCount = vals.size();
                     rs.close();
                     connection.close();
                     statement.close();
                  }
                  else {
                     // create a complete SQL program
                     String tmpDataName = "_wbuvl" + hrvDSC.hashCode();
                     StringBuffer sqlBuf = new StringBuffer();
                     sqlBuf.append("PROC SQL;");
                     sqlBuf.append("CREATE TABLE ");
                     sqlBuf.append(tmpDataName);
                     sqlBuf.append(" as ").append(selectClause.toString());
                     sqlBuf.append(";QUIT;");

                     // submit the SAS/SQL code to create the temp table
                     cI.submit(sqlBuf.toString());
                
                     //get a DataSetInterface to read the new table
                     Rocf rocf = cI.getRocf();
                     DataSetInterface dsI = (DataSetInterface)rocf.newInstance(DataSetInterface.class, cI.getCon()); 
                     dsI.setDataSet(tmpDataName);      //set the dataset name/options
                
                     // see how big the results table is
                     rowCount = dsI.getRowCount();
                     if (rowCount == -1) {
                        int MAX_IN_OBS = 0;
                        rowCount = dsI.countRows(MAX_IN_OBS);
                     }
 
                     // read each record into the vals named list
                     for (int i=1; i<=rowCount; i++) {
                        switch (hrvDSC.getDataType()) {
                           case Expression.EXP_TYPE_TIME:
                              formatted = dsI.getFormattedCell(i, 1);
                              unformatted = dsI.getFormattedCell(i, 2);
                              break;
                           case Expression.EXP_TYPE_DATE:
                              formatted = dsI.getFormattedCell(i, 2);
                              unformatted = getInternationDate(dsI.getCell(i, 1), request);
                              break;
                           case Expression.EXP_TYPE_TIMESTAMP:
                              formatted = dsI.getFormattedCell(i, 2);
                              unformatted = dsI.getFormattedCell(i, 2);
                              break;
                           default:
                              formatted = dsI.getFormattedCell(i, 1);
                              unformatted = dsI.getCell(i, 1);
                           break;
                        }
                        if (unformatted == null || dsI.getCell(i, 1) instanceof com.sas.MissingValues) {
                           unformatted = "";
                        } 
                        else {
                           //if (!formatted.trim().equals(unformatted.toString().trim())) {
                           //   formatted = formatted + " ("+unformatted.toString()+")";
                           //}
                        }
                        vals.add(unformatted.toString(), formatted);
                     }  
                  
                     // clean up
                     dsI.close();
                     dsI.setDataSet(null);
                  }

                  // 27feb04 - modified to use the listbox model only if the size of the vals named list is 
                  // smaller than a specified threshold
                  request.setAttribute("startTime", new Long(System.currentTimeMillis()));                  
                  if ((vals != null) && (vals.size() > 10000)) {
                     request.setAttribute("vals", vals);
                  }
                  else if ((vals != null) && (vals.size() > 0)) {
                     for (int k=0; k<vals.length(); k++ ) {
                        desc_model.add(vals.getValue(k));
                        model.add(vals.getName(k));
                     }
                     valuesBean.setModelInterface(model);
                     valuesBean.setDescriptionModel(desc_model);
                     request.setAttribute("valuesBean", valuesBean);
                  } 
                  else {
                     request.setAttribute("error.msg", bundle.getString("Values.Message.NoActualValues.txt"));
                  }
               } 
               else {
                  //null value list was returned
                  request.setAttribute("error.msg", bundle.getString("Query.Message.InvalidPhysicalData.txt"));
               }
            } 
            else {
               //does not support distinct values
 //            request.setAttribute("error.msg", bundle.getString("Values.Message.NoActualValues.txt"));
               request.setAttribute("error.msg", "Does not support distinct values");
            }
//System.out.println("\nGenerate actual values - Time: " + (System.currentTimeMillis() - startTime)); 
         } 
     
         // this section is for a display of possible values
         else if (TYPE_POSSIBLE.equalsIgnoreCase(typeString)) {
//application.log("processing 'possible values' request...");
            StringCollection model = new StringCollection();
            StringCollection desc_model = new StringCollection();
            Column column = expression.getColumn();

            String format = column.getFormat();
            if (format != null && format.trim().length() > 0) {
               String[] sasF = com.sas.text.SASFormat.parseFormat(format);
               if (sasF != null)
                  format=sasF[0];   //0=base, 1=width, 2=decimal

//         String[] vals = ((HRVDataSource)m_dataSource).getPossibleValues(format);
//         NamedList vals = ((HRVDataSource)m_dataSource).getPossibleValuesList(format);
               NamedList vals = getPossibleValuesList(m_dataSource, session, format);

               if (vals != null) {
                  if (vals.size() > 0) {
                     ConstantExpression constExp = new ConstantExpression();
                     for (int k=0; k<vals.size(); k++ ) {
                        String formatted = vals.getValue(k).toString();
                        String unformatted = vals.getName(k);
                        if (!formatted.trim().equals(unformatted.toString().trim())) {
                           formatted = formatted + " ("+unformatted.toString()+")";
                        }
                        desc_model.add(formatted);
                        constExp.setValue(vals.getName(k), expression.getDataType());
                        model.add(constExp.generateSQL(m_query.getSqlLogic(), Expression.EXP_GEN_DECLARATION));
                     }
                     request.setAttribute("valuesBean", valuesBean);
                  } 
                  else {
                     //no possible values could be found!
                     request.setAttribute("error.msg", bundle.getString("Values.Message.NoPossibleValues.txt"));
                  }
               }
               else {
                  //null value list was returned
                  request.setAttribute("error.msg", bundle.getString("Query.Message.InvalidPhysicalData.txt"));
               }
               valuesBean.setModelInterface(model);
               valuesBean.setDescriptionModel(desc_model);
            } 
            else {
               //the format is too ambiguous to determine any possible values.
               request.setAttribute("error.msg", bundle.getString("Values.Message.NoPossibleValues.txt"));
            } 
         } 
          
         // This section deals with user prompts 
         else if (TYPE_USER.equalsIgnoreCase(typeString)) {
            ////////////////////////////////////////////////////////////////////////////////
            //check for prompt delete request first
            String action = request.getParameter("intAction");
            if ("delete".equalsIgnoreCase(action)) {
               //user has requested to delete a key (more than one?)
               String[] upKeys = request.getParameterValues("values");
               if (upKeys != null) {
                  UserPromptBean upb = new UserPromptBean(session);
                  upb.setUser(hrvi.getUser(session));
                  for (int i=0; i<upKeys.length; i++) {
                     String key = upKeys[i];
                     if (key.length() > 1) {
                        //it should be longer than 1 char - always
                        key = key.substring(1);
                     }
                     try {
                        upb.setMetaKey(key);
                        //BKD:FIX! the location a prompt is coming from is
                        //being lost.  We're probably safe for now because I
                        //don't think that hr vision is supporting a public
                        //set of user prompts, but this really should be done
                        //better.
//              upb.setMetaLocation(MetaBean.PRIVATE_LOC);
                        upb.setTrueLocation(expression.getDataType(), MetaBean.PRIVATE_LOC);
//             application.log("removing prompt: " + key);
                        upb.removeItem();
                     } 
                     catch(Exception e) {
   //                   application.log("Exception caught while removing prompt("+key+") - " + e.getMessage());
                        //BKD:FIX - we should be surfacing reasonable errors
                        //to the user by way of localized messages
                        m_messages.addError(e.getMessage());
                     }
                  }

                  if (m_messages.hasMessages()) {
                     StringBuffer errMsg = new StringBuffer();
                     String[] msgs = m_messages.getMessages();
                     m_messages.removeAllMessages();
                     for (int j=0; j<msgs.length; j++) {
                        if (j > 0)
                           errMsg.append("<BR>\n");
                        errMsg.append(msgs[j]);
                     }
                     request.setAttribute("error.msg", errMsg.toString());
                  }
               }
            }

            ////////////////////////////////////////////////////////////////////////////////
            //application.log("processing 'parameters' request...");
            StringCollection model = new StringCollection();
            StringCollection desc_model = new StringCollection();
            UserPromptBean upb = new UserPromptBean(session);
            upb.setUser(hrvi.getUser(session));
            TableBean tableBean = new TableBean(session);   //BKD:FIX!
            //      tableBean.setMetaKey("query");
            //BKD:FIX - we should grab a list from the datasource here
            NamedList nl;
            if (expression == null){
               nl = upb.getValidPrompts(parenExpression.getExpression().getDataType(),tableBean, true);
            }
            else
               nl = upb.getValidPrompts(expression.getDataType(), tableBean);
         
            for (int i=0; i<nl.size(); i++) {
               model.add("&" + nl.getName(i));
      
               upb = (UserPromptBean)nl.getValue(i);
               desc_model.add("("+upb.getCurrentKey()+")"+upb.getAttributeValue("desc"));
            }
            //sort values
            StringCollection[] models = { model, desc_model };
            multiSort(models, 1);
            valuesBean.setModelInterface(model);
            valuesBean.setDescriptionModel(desc_model);

            request.setAttribute("valuesBean", valuesBean);
         } //else i do not know...
         
// ### ADDITIONS FOR COLUMN SELECTION
			else if (TYPE_COLUMN.equalsIgnoreCase(typeString)) 
			{
				// get model & desc from columnsModel
				StringCollection[] columnModels = new StringCollection[2];
				columnModels[0] = new StringCollection();
				columnModels[1] = new StringCollection();

				for (int i=0; i<m_itemList.size(); i++) 
				{
					DataItem item = m_itemList.elementAt(i);
					
					//## Calculated columns need to be taken out of this list###
					boolean isCalculated = isCalculatedColumn(m_query, (JspDataItem)item);
					
					if(isCalculated)
						continue;
					
					//##########################################################
					
					SqlLogic logic = m_query.getSqlLogic();
					
					
					ColumnExpression colexp = (ColumnExpression)item.getExpression();
					Column col = colexp.getColumn();
					String columnName = logic.genColumnName( col );
					columnModels[0].add(COLUMN_PREFIX+columnName);
		
					String itemLabel = getLabelForDataItem((JspDataItem)item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
					columnModels[1].add(itemLabel);
				}

				valuesBean.setModelInterface(columnModels[0]);
				valuesBean.setDescriptionModel(columnModels[1]);
				request.setAttribute("valuesBean", valuesBean);
			}
// ### DONE WITH ADDITIONS
         
         
      }
   }

//Send the request to the view page for visualization
pageContext.forward((String)request.getAttribute("viewURL"));
%>

<%!
   public NamedList getActualValues(HRVDataSourceColumn hrvColumn)
   {
      NamedList values = null;



      return values;
   }

   long m_fmtIndex = 0;

   public NamedList getPossibleValuesList(DataSource m_dataSource, HttpSession session, String format)
   {
      NamedList nl = null;
      try {
     String default_name = "work.qFmtInfo";
     synchronized (m_dataSource) {
        default_name = default_name + m_fmtIndex;
        m_fmtIndex++;
     }
         DataSetInterface dsI = (DataSetInterface)getFormatDataSetInterface(session, ItemBean.PUBLIC_DATA_LIBREF, format, default_name);

     nl = new NamedList();
     int rowCount = dsI.countRows(0);
     Object[][] data = dsI.getCells(1, 2, rowCount, 3);
     for (int i=0; i<data.length; i++) {
        Object[] rowData = data[i];
        nl.add(rowData[0].toString(), rowData[2]);
     }

     return nl;
      } catch(Exception e) {
     e.printStackTrace();
         m_dataSource.getMessageHandler().addError(e);
      }

      return nl;
   }

   protected Object getFormatDataSetInterface(HttpSession session, String library, String format, String datasetName)
      throws Exception
   {
//      String sqlFormat = "PROC FORMAT FMTLIB LIBRARY={0} CNTLOUT={1}; SELECT {2}; RUN;";
      String sqlFormat = "PROC FORMAT FMTLIB LIBRARY=LIBRARY CNTLOUT={1}; SELECT {2}; RUN;";
      Object[] args = { library, datasetName, format };

      ConnectionInterface cI = ConnectionInterface.getInstance(session);
      cI.submit(java.text.MessageFormat.format(sqlFormat, args));
      Connection connection = cI.getCon();
      Rocf rocf = cI.getRocf();

      DataSetInterface dsI = (DataSetInterface)rocf.newInstance(DataSetInterface.class, connection);
      dsI.setDataSet(datasetName);

      return dsI;
   }
   
   public Object getInternationDate(Object daysSince, HttpServletRequest request){
	//dayssince is the number of days since 1/1/1960
	//need to convert to an internatialized data9. format
	GregorianCalendar calendar = new GregorianCalendar(1960, 00, 01);
	SimpleDateFormat sdf = new SimpleDateFormat("ddMMMyyyy", request.getLocale());
	String stringDays = daysSince.toString();
	if(!stringDays.equals("Dot")){
		Double d = new Double(stringDays);
		int days = d.intValue();
		calendar.add(Calendar.DATE, days);
		sdf.setCalendar(calendar);	
		
		daysSince = (Object)sdf.format(calendar.getTime());
		
		//returning formatted date
		return daysSince;
	
	}
	//returning "Dot" text
   	return daysSince;
   }
%>
