
<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     expressionBuilder.jsp
// AUTHOR:   maperr - Matthew Perry
// SUPPORT:  maperr - Matthew Perry
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  UI for building expressions in the Query facility
//			 and to prove JavaScript can be a nightmare!
//
// HISTORY:   Date      Who     Action
//           -------------------------------------------------------
//           30 OCT 01  maperr  initial code
//			 01 NOV 01  maperr  added the ability to select data types	
//			 05 FEB 02  maperr  Added Constant and Substring capability
/*********************************************************************/
%>

<%

	//determine if this is an advanced query. 
	//TODO: Get attribute value from properties
	
	OptionBean oB = OptionBean.getInstance(session);
	String someValue = oB.getOption("advanced_query");
	if(someValue == null)
		someValue = "NO";


	boolean advanced = false;
	if(someValue.equalsIgnoreCase("YES"))
		advanced = true;
		
		
	String lockString = "";
	if(advanced)
		lockString = "disabled";
	else
		lockString = "onChange=\"changeContent();\"";
	
	
	//getting message system
	VisMsg vm = VisMsg.getInstance(session);
	
	//field labels
	String dataType = vm.getLabel("DataType");
	String columns = vm.getLabel("Columns");
	String operators = vm.getLabel("operators");
	String functions = vm.getLabel("functions");
	String noMatch = vm.getLabel("noMatchParan");
	
	//radio labels
	String tlv = vm.getLabel("toLastValue");
	String tlp = vm.getLabel("toLastParan");
	String tex = vm.getLabel("toEntireExp");
	
	//button labels
	String undo = vm.getLabel("undo");
	String clear = vm.getLabel("Clear");
	
	//function labels
	String abs = vm.getLabel("abs");
	String floor = vm.getLabel("floor");
	String ceil = vm.getLabel("ceiling");
	String round = vm.getLabel("round");
	String sqr = vm.getLabel("squareRoot");
	String eNth = vm.getLabel("eNth");
	String log = vm.getLabel("log");
	String datejul = vm.getLabel("julianToStandard");
	String stripLeadingBlanks = vm.getLabel("stripLeadingBlanks");
	String substringFunction = vm.getLabel("substringFunction");
	String stripTrailingBlanks = vm.getLabel("stripTrailingBlanks");
	String leftJustify = vm.getLabel("leftJustify");
	String rightJustify = vm.getLabel("rightJustify");
	String convertToNumeric = vm.getLabel("convertToNumeric");
	String upperCase = vm.getLabel("upperCase");
	String lowerCase = vm.getLabel("lowerCase");
	String reverse = vm.getLabel("reverse");
	String standardToJulian = vm.getLabel("standardToJulian");
	String weekday = vm.getLabel("weekday");
	String dayPart = vm.getLabel("dayPart");
	String monthPart = vm.getLabel("monthPart");
	String yearPart = vm.getLabel("yearPart");
	String todayFunction = vm.getLabel("todayFunction");
	String datePart = vm.getLabel("datePart"); 
	String timePart = vm.getLabel("timePart"); 
	String startSubstring = vm.getLabel("startSubstring");
	String endSubstring = vm.getLabel("endSubstring");
	String constant = vm.getLabel("expressionConstant");
	String enterConstant = vm.getLabel("enterConstant");
	String enterDateConstant = vm.getLabel("enterDateConstant");
	String enterTimeConstant = vm.getLabel("enterTimeConstant");
	
	//data type labels
	String date = vm.getLabel("date");
	String time = vm.getLabel("time");
	String currency = vm.getLabel("currency");
	String character = vm.getLabel("character"); 
	String numeric = vm.getLabel("numeric");
	String dateTime = vm.getLabel("dateTime");
	
	//form elements
	String formname = "initQry";
	String operatorName = "operator";
	String columnName = "column";
	String func = "functions";

	//getting the type to set the selection fields
	String writeType = request.getParameter("writeType");
%>

<TR>
<TD COLSPAN=2 ALIGN=CENTER><SPAN CLASS="ERRMSG"></SPAN></TD></TR>
</TABLE>
<TABLE CLASS="ENTRYBOX" BORDER=0 CELLSPACING=2 width=733 align=center>
<TR>
	<TD><%=dataType%></TD>
	<TD><%=columns%></TD>
	<TD><%=operators%></TD>
	<TD><%=functions%></TD>
</TR>
<TR>
<TD>
	<!--Selection field for the data type -->
	<select name="dataType" size="5" <%=lockString%>>
		<option value="char"><%=character%></option>
		<option value="date"><%=date%></option>
		<option value="num"><%=numeric%></option>
		<option value="time"><%=time%></option>
		<option value="dateTime"><%=dateTime%></option>
	</select>
</TD>
<TD>
<!-- column selector -->
<select name="<%=columnName%>" size="5" onChange="handleSelection ('<%=columnName%>', '<%=operatorName%>');">
<%
	//add the left paran to the option list
	out.println("<option value=\"(\">");
	out.println("(");
	out.println("</option>");
	String testLabel = "", desc = "", output="";
	int firstRightParan = 0;
	
	//if null set it to numeric
	if(writeType == null)
		writeType = "num";
	
	//getting the selected list
	DataItemList allItems = ((HRVQuery)m_query).getPersistedItemList();
	
	//### maperr 5/25/04 Check to see if a join condition exists? ########
	List tableList = new ArrayList();
	for(int j=0; j < allItems.size(); j++){
		DataItem item = allItems.elementAt(j);//column name
		JspDataItem jspItem = (JspDataItem)item;
		Expression expression = jspItem.getSafeExpression();
		if (expression instanceof ColumnExpression) {           
			Column column = ((ColumnExpression)expression).getColumn();
			com.sas.query.models.Table table = column.getParent();
			String tableName = table.getDisplayName();
			if(!tableList.contains(tableName))
				tableList.add(tableName);
     		}
	}
	//###################################################################
	
	for (int i=0; i<allItems.size(); i++) {
		int number = 0;
		boolean itemFound = false;
   		DataItem item = allItems.elementAt(i);//column name
   		
   		
   		//## maperr 5/25/04 Stuff to add table name ##
   		
   		String tableName = "";
   		
   		if(tableList.size()>1){
   			try{
   		
				JspDataItem jspItem = (JspDataItem)item;
				Expression expression = jspItem.getSafeExpression();
				if (expression instanceof ColumnExpression) {           
					Column column = ((ColumnExpression)expression).getColumn();
					com.sas.query.models.Table table = column.getParent();
					tableName = table.getDisplayName() + ".";
				}
				
			}catch(Exception e){
				System.out.println(e);
			}
		}
   		//############################################
   		
   		number = getDataType(m_query, item);
   		boolean isCalculated = isCalculatedColumn(m_query, (JspDataItem)item);		

		//if type is char, only show char column types
		if((( writeType.equalsIgnoreCase("char")) && (number == 4) && isCalculated != true) || advanced){
			testLabel = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
			firstRightParan = testLabel.indexOf(")");
			desc = testLabel.substring(firstRightParan + 1);
			output = "(" + item + ")" + " " + desc;
			itemFound = true;
		}
		//if type is currency or numeric show currency and numeric
		if(((writeType.equalsIgnoreCase("curr") || writeType.equalsIgnoreCase("num")) && (number == 2 || number == 16) && isCalculated != true) || advanced){
			testLabel = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
			firstRightParan = testLabel.indexOf(")");
			desc = testLabel.substring(firstRightParan + 1);
			output = "(" + item + ")" + " " + desc;
			itemFound = true;
		} 
		//if type is date show numeric and date
		if((( writeType.equalsIgnoreCase("date") || writeType.equalsIgnoreCase("time")) && (number == 2 || number == 16) && isCalculated != true) || advanced){
			testLabel = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
			firstRightParan = testLabel.indexOf(")");
			desc = testLabel.substring(firstRightParan + 1);
			output = "(" + item + ")" + " " + desc;
			itemFound = true;
		}
		//if the type is date/time
		if(((writeType.equalsIgnoreCase("dateTime")) && (number == 2) && isCalculated != true) || advanced){
			testLabel = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
			firstRightParan = testLabel.indexOf(")");
			desc = testLabel.substring(firstRightParan + 1);
			output = "(" + item + ")" + " " + desc;
			itemFound = true;
		}
		
		//if the data type is somthing that is not used currently, put it in the list
		if((number != 2 && number != 4 && number != 16 && number != 0) || advanced){
			testLabel = getLabelForDataItem(item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");
			firstRightParan = testLabel.indexOf(")");
			desc = testLabel.substring(firstRightParan + 1);
			output = "(" + item + ")" + " " + desc;
			itemFound = true;
		}
		
		//if the string is not blank, output it!
		if((itemFound == true) || advanced){
			out.println ("<option value=\"" + tableName + item +"\">");
			out.println (output);
			//out.println (testLabel); //with library and table name
			out.println ("</option>");
		}
	}
	out.println("<option value=\"today()\">");
	out.println("today()");
	out.println("</option>");
			
%>
</select>
</TD>
<script language="javascript">
<!--
	var undoStack, leftPar=0, rightPar=0, currentPar, currentX, sasFunction, writeType, lastValue, activeOperator;
	var currentFunction, lastParm, functionPlacement;
	var textToAdd = "";
	//determine what kind of content we are dealing with
	writeType = '<%=writeType%>';
	
	function handleSelection (activeFormField, inactiveFormField) {
				
		activeControl = getControl (activeFormField);
		inactiveControl = getControl (inactiveFormField);
		document.<%=formname%>.undo.disabled = false;

		textToAdd = activeControl.options[activeControl.selectedIndex].value;
		activeControl.selectedIndex = -1;
		inactiveControl.selectedIndex = -1;
		
		//if we get a paran, add it, but dont change control
		if(textToAdd == "("){ 
			leftPar = leftPar + 1;
			currentPar = textToAdd;
			addToTextArea(textToAdd);
			addToUndoStack(activeFormField, textToAdd);
			return;
		}
		if(textToAdd == ")"){
			if(leftPar == 0 || leftPar == rightPar){
				alert('<%=noMatch%>');
				return;
			}else{
				rightPar = rightPar + 1;
				currentPar = textToAdd;
				addToTextArea(textToAdd);
				addToUndoStack(activeFormField, textToAdd);
				return;
			}
		}
	
		//This stuff takes care of triming a character value
		if(textToAdd == "||"){	 
			var fullExpression = document.<%=formname%>.<%=selectedTextarea%>.value;
			var trimedExpression = "", indexOfExpression=0;
			if(currentFunction == "" || currentFunction == null){
				if(currentPar == ')')
					trimedExpression = "trim(" + lastValue + "))";
				else
					trimedExpression = "trim(" + lastValue + ")";
				indexOfExpression = fullExpression.lastIndexOf(lastValue);
				fullExpression = fullExpression.substr(0,indexOfExpression);
				fullExpression = fullExpression + trimedExpression;
				document.<%=formname%>.<%=selectedTextarea%>.value = fullExpression;
			}else{
				//place the trim in proper place due to function
				if(functionPlacement == "TEX"){
					trimedExpression = "trim(" + currentFunction + ")";
					indexOfExpression = fullExpression.lastIndexOf(currentFunction);
					fullExpression = fullExpression.substr(0,indexOfExpression);
					fullExpression = fullExpression + trimedExpression;
				}else if(functionPlacement == "TLV"){
					trimedExpression = "trim(" + currentFunction + ")";
					indexOfExpression = fullExpression.lastIndexOf(currentFunction);
					fullExpression = fullExpression.substr(0,indexOfExpression);
					fullExpression = fullExpression + trimedExpression;
				}else if(functionPlacement == "TLP"){
					//support this??
				}			
				document.<%=formname%>.<%=selectedTextarea%>.value = fullExpression;
			}
			currentFunction = "";
		}
		
		lastParm = currentPar;
		currentPar = textToAdd;
		
		if(activeFormField == "column"){
			document.<%=formname%>.constant.disabled=true;
			document.<%=formname%>.<%=func%>.disabled= false;
			
			lastValue = textToAdd;
		}
		else{
			document.<%=formname%>.<%=func%>.disabled= true;
			document.<%=formname%>.constant.disabled=false;
		}
		addToTextArea (textToAdd);
		addToUndoStack (activeFormField, textToAdd);
		switchFields (activeControl, inactiveControl);
	}
	
	function undoLastChange () {
		currentFunction = "";
		currentPar = lastParm;
		if (undoStack != null) {
			// remove it from the undoStack
			removeLastFromStack ();
			// remove it from the text area field			
			removeLastFromFormula ();
		}	
		// if we haven't added anything to the stack, there is nothing to remove
	}
	
	function removeLastFromFormula () {
		// find out what was added last
		lastUndoText = undoStack[undoStack.length - 1];
		textString = new String (lastUndoText);
		var lastElement = textString.substring(textString.length - 1);
		colonIndex = textString.indexOf (':');
		// remove string is the text to remove
		currentFormula = textString.substring (colonIndex + 1);
		// item string is the item to enable
		itemString = textString.substring (0, colonIndex);
		if(activeOperator == 'true' && lastElement == ')'){
			itemString = 'column';
		}
		enableCorrectField (itemString); 
		if (currentFormula == 'undefined'){
			currentFormula = '';
			initialDisplay(); 
		}
		document.<%=formname%>.<%=selectedTextarea%>.value = currentFormula;
	}
	
	function enableCorrectField (toBeMadeActive) {
		if (toBeMadeActive == '<%=operatorName%>') {
			document.<%=formname%>.<%=func%>.disabled = true;
			document.<%=formname%>.constant.disabled=false;
			activeControl = getControl ('<%=operatorName%>');
			inactiveControl = getControl ('<%=columnName%>');
		} else if (toBeMadeActive == '<%=columnName%>') {
			document.<%=formname%>.<%=func%>.disabled = false;
			document.<%=formname%>.constant.disabled=true;
			activeControl = getControl ('<%=columnName%>');
			inactiveControl = getControl ('<%=operatorName%>');
		}
		if(toBeMadeActive == null || toBeMadeActive == ""){
			activeControl = getControl ('<%=operatorName%>');
			inactiveControl = getControl ('<%=columnName%>');
		}
		switchFields (activeControl, inactiveControl);
	}
	
	function removeLastFromStack () {
		if (undoStack != null && undoStack.length > 0) {
			tempArray = createTemporaryArray (undoStack);
			//determine the item being removed
			var lastNumber = undoStack.length;
			var itemLeaving = undoStack[lastNumber-1];
			var leavinglength = itemLeaving.length;
			var lastItem = itemLeaving.substring(leavinglength - 1);
			if(lastItem == ')')
				rightPar--;
			if(lastItem == '(')
				leftPar--;
			if(lastItem == '*' || lastItem == '/' || lastItem == '+' || lastItem == '-' || lastItem == ')')
				activeOperator = 'true';
			else
				activeOperator = '';
			// decrease size of the stack
			undoStack = new Array (undoStack.length - 1);
			
			// add back old items to the stack
			for (i = 0; i < undoStack.length; i++) {
				undoStack[i] = tempArray[i];
			}
		}
	}
	
	function addToUndoStack (activeControl, addedText) {
		// if there is already an undo stack, then save the old one
		if (undoStack != null) {
			// create temporary array
			tempArray = createTemporaryArray (undoStack);
		
			// increase size of array
			undoStack = new Array (tempArray.length + 1);
		
			// add back old items to the stack
			for (i = 0; i < tempArray.length; i++) {
				undoStack[i] = tempArray[i];
			}
		} else {
		// otherwise, you've got to create the stack
			undoStack = new Array (1);
		}
		
		// add the newest item
		undoStack[undoStack.length - 1] = activeControl + ':' +
			document.<%=formname%>.<%=selectedTextarea%>.value;
	}
	
	function createTemporaryArray (arrayToCopy) {
		tempArray = new Array (arrayToCopy.length);
		
		for (arrayIndex = 0; arrayIndex < arrayToCopy.length; arrayIndex++) {
			tempArray[arrayIndex] = arrayToCopy[arrayIndex];
		}
		
		return tempArray;
	}
	
	function enterConstant(){
		var constant = '';
		if(writeType == "char"){
			constant = prompt("<%=enterConstant%> ", "");
			if(constant == null || constant == "")
				return;
			else
				constant = "\"" + constant + "\"";
		}
		
		if(writeType == "num"){
			constant = prompt("<%=enterConstant%> ", "");	
			if(constant == null || constant == "")
				return;
		}
		
		if(writeType == "date"){
			constant = prompt("<%=enterDateConstant%> ", "");	
			if(constant == null || constant == "")
				return;
			else{
				var index = constant.indexOf('/');
				if(index != -1)
					constant = "input("+constant+", DDMMYY8.)";
	
			}
		}
		
		if(writeType == "time"){
			constant = prompt("<%=enterTimeConstant%> ", "");	
			if(constant == null || constant == "")
				return;
			else
				constant = "\"" + constant + "\"T";
		}
		/*
		if(writeType == "dateTime"){
			
			if(constant == null || constant == "")
				return;
			else
				constant = "\"" + constant + "\"DT";
			
		}*/
		
		activeControl = getControl ('<%=columnName%>');
		inactiveControl = getControl ('<%=operatorName%>');
			
		lastValue = constant;
		currentPar = constant;
		addToTextArea(constant);
		addToUndoStack('<%=columnName%>', constant);
		switchFields(activeControl, inactiveControl);
		document.<%=formname%>.<%=func%>.disabled= false;
		document.<%=formname%>.constant.disabled=true;
	}
	
	// make the alternate field active
	function switchFields (active, inactive) {
		active.disabled = true;
		inactive.disabled = false;
	}

	// get the control object based on a string
	function getControl (formField) {
		thisCtrl = eval ('document.<%=formname%>.' + formField);
		
		return thisCtrl;
	}
	
	// add this text to the already existing text in the textarea
	function addToTextArea (additionalText) {
		document.<%=formname%>.<%=selectedTextarea%>.value = 
			document.<%=formname%>.<%=selectedTextarea%>.value + 
			' ' + additionalText;
	}
	
	function chooseFunctionType(){
		//determine what kind of radio options to display
		
		var functionType = document.initQry.functions.value;

		if(functionType == "today"){
			document.initQry.TLV.disabled = false;
			document.initQry.TEX.disabled = false;
			document.initQry.TLP.disabled = false;
			setTodayFunction();
			
		}
		if(functionType == "substr"){
			document.initQry.TLV.disabled = false;
			document.initQry.TEX.disabled = false;
			return;
		}
		if(currentPar == ")"){
			document.<%=formname%>.TLV.disabled = false;
			document.<%=formname%>.TLP.disabled = false;
			document.<%=formname%>.TEX.disabled = false;
		}
		else{
			document.<%=formname%>.TLV.disabled = false;
			document.<%=formname%>.TEX.disabled = false;
		}
	}
	
	function setTodayFunction(){
		alert('set today');
	}
	
	function processFunction(radioType, formType){
		
		var frontString, endString, middleString, lastIndexO = 0;
		currentX = document.<%=formname%>.<%=selectedTextarea%>.value;
		sasFunction = document.<%=formname%>.<%=func%>.value;
		document.<%=formname%>.<%=func%>.selectedIndex = -1;
		
		//display popup menu for substring functions
		if(sasFunction == "substr"){
			lastIndexO = currentX.lastIndexOf(currentPar);
			var start = prompt('<%=startSubstring%> ','');
			if(start == '' || start == null)
				return;
			var end = prompt('<%=endSubstring%> ','');
			if(start != null){
				currentX = currentX.substr(0, lastIndexO);
				if(end == "")
					endString = currentPar + "," + start;
				else
					endString = currentPar + "," + start + "," + end;
				currentX += endString;
				lastParm = currentPar;
			}
		}
		
		//############### any new functions that require values need to be referenced by their option name ########
		//#########################################################################################################
		
		
		
		
		
		
		
		//#########################################################################################################
		//#########################################################################################################
		
		
		if(radioType == 'TLV'){
			//do to last value parse. Do this by last space		
			lastIndexO = currentX.lastIndexOf(lastValue);
			frontString = currentX.substr(0, lastIndexO);
			endString = currentX.substr(lastIndexO);	
			currentX = frontString + ' ' + sasFunction + '(' + endString +')';
			currentFunction = sasFunction + '(' + endString +')';
			functionPlacement = "TLV";
			rightPar++;
			leftPar++;		
		}
		
		//add a sas function to the last parenthesized value
		if(radioType == 'TLP'){
			//can find the last left paran and substring it up to the next right paren
			lastIndexO = currentX.lastIndexOf('(');
			frontString = currentX.substr(0, lastIndexO);
			endString = currentX.substr(lastIndexO);
			currentX = frontString + '(' + sasFunction + endString + ')';
			lastParm = currentPar;
			currentPar = ')';
			currentFunction = '(' + sasFunction + endString + ')';
			functionPlacement = "TLP";
			rightPar++;
			leftPar++;
		}
		
		//add sas function to the entire expression
		if(radioType == 'TEX'){
			var closeRightParan = '', closeLeftParan = '';
			currentX = sasFunction + '(' + currentX + ' )';
			lastParm = currentPar;
			currentPar = ')';
			currentFunction = currentX;
			functionPlacement = "TEX";
			leftPar++;
			rightPar++; 
		}
		
		//setting the text field and unchecking the radio boxes
		document.<%=formname%>.<%=selectedTextarea%>.value = currentX;
		addToUndoStack('<%=operatorName%>', currentX);
		
		document.<%=formname%>.TLV.checked = false;
		document.<%=formname%>.TLP.checked = false;
		document.<%=formname%>.TEX.checked = false;	
		document.<%=formname%>.TEX.disabled = true;	
		document.<%=formname%>.TLP.disabled = true;
		document.<%=formname%>.TLV.disabled = true;
	}
	
	function initialDisplay(){
		leftPar = 0;
		rightPar = 0;
		document.<%=formname%>.<%=columnName%>.disabled = false;
		document.<%=formname%>.<%=operatorName%>.disabled = true;
		document.<%=formname%>.<%=func%>.disabled = true;
		document.<%=formname%>.TLV.checked = false;
		document.<%=formname%>.TLP.checked = false;
		document.<%=formname%>.TEX.checked = false;	
		document.<%=formname%>.TEX.disabled = true;	
		document.<%=formname%>.TLP.disabled = true;
		document.<%=formname%>.TLV.disabled = true;
		
		if(writeType == "dateTime")
			document.<%=formname%>.constant.disabled=true;
		else
			document.<%=formname%>.constant.disabled=false;
		lastValue = "";
		currentFunction = "";
	}
	
	function changeContent(){
		var dataType;
		dataType = document.<%=formname%>.dataType.value;
		reloadPage(dataType);
	}
	
	function reloadPage(newType){
		//reload the screen with the proper contents
		var name, label, returnTo;
		name = document.<%=formname%>.name.value;
		label = document.<%=formname%>.label.value;
		returnTo = document.<%=formname%>.returnTo.value;
		//####changes here####
		parent.HRVContent.document.location.href='../Query/<%=pageName%>.jsp?sessionkey=<%=m_sessionKey%>&writeType=' + newType + '&name=' + name + '&label=' + label + '&returnTo=' + returnTo; 
	}
//-->
</script>
<%
	if((writeType == null || writeType.equalsIgnoreCase("num") || writeType.equals("")) && !advanced){
		//write the numeric options
		%>
		<TD>
		<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
			<option value="+">+</option>
			<option value="-">-</option>
			<option value="*">*</option>
			<option value="/">/</option>
			<option value=")">)</option>
		</select>
		</TD>
		
		<TD>
		<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
			<option value="abs"><%=abs%></option>
			<option value="floor"><%=floor%></option>
			<option value="ceil"><%=ceil%></option>
			<option value="round"><%=round%></option>
			<option value="weekday"><%=weekday%></option>
			<option value="day"><%=dayPart%></option>
			<option value="month"><%=monthPart%></option>
			<option value="year"><%=yearPart%></option>
		</select>
		</TR>
		<script>
			document.<%=formname%>.dataType.options[2].selected = true;
		</script>
		<%
	}
	
	if((writeType.equalsIgnoreCase("char")) && !advanced){
		//write the char stuff
		%>
			<TD>
			<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
				<option value="||">||</option>
				<option value=")">)</option>
			</select>
			</TD>

			<TD>
			<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
				<option value="substr"><%=substringFunction%></option>
				<option value="trim"><%=stripTrailingBlanks%></option>
				<option value="left"><%=leftJustify%></option>
				<option value="right"><%=rightJustify%></option>
				<option value="upcase"><%=upperCase%></option>
				<option value="lowcase"><%=lowerCase%></option>
			</select>
			</TR>	
			<script>
				document.<%=formname%>.dataType.options[0].selected = true;
			</script>
		<%		
	}
	
	if((writeType.equalsIgnoreCase("date")) && !advanced){
		//write the date stuff
		%>
			<TD>
			<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
				<option value="+">+</option>
				<option value="-">-</option>
				<option value="*">*</option>
				<option value="/">/</option>
				<option value=")">)</option>
			</select>
			</TD>

			<TD>
			<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
			</select>
			</TR>
			<script>
				document.<%=formname%>.dataType.options[1].selected = true;
			</script>
		<%
	}
	
	if((writeType.equalsIgnoreCase("time")) && !advanced){
		//write the time stuff
		%>
			<TD>
			<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
				<option value="+">+</option>
				<option value="-">-</option>
				<option value=")">)</option>
			</select>
			</TD>

			<TD>
			<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
			</select>
			</TR>
			<script>
				document.<%=formname%>.dataType.options[3].selected = true;
			</script>
		<%
	}
	
	if((writeType.equalsIgnoreCase("dateTime")) && !advanced){
		//write the dateTime stuff
		%>
			<TD>
			<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
				<option value="+">+</option>
				<option value="-">-</option>
				<option value=")">)</option>
			</select>
			</TD>

			<TD>
			<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
				<option value="datepart"><%=datePart%></option>
				<option value="timepart"><%=timePart%></option>
			</select>
			</TR>
			<script>
				document.<%=formname%>.dataType.options[4].selected = true;
			</script>
		<%
	}
	
	if(advanced){
		%>
			<TD>
			<select name="<%=operatorName%>" size="5" onChange="handleSelection ('<%=operatorName%>', '<%=columnName%>');">
				<option value="||">||</option>
				<option value="+">+</option>
				<option value="-">-</option>
				<option value="*">*</option>
				<option value="/">/</option>
				<option value=")">)</option>
			</select>
			</TD>

			<TD>
			<select name="<%=func%>" size="5" onChange="chooseFunctionType(); ">
				<option value="abs"><%=abs%></option>
				<option value="floor"><%=floor%></option>
				<option value="ceil"><%=ceil%></option>
				<option value="round"><%=round%></option>
				<option value="weekday"><%=weekday%></option>
				<option value="day"><%=dayPart%></option>
				<option value="month"><%=monthPart%></option>
				<option value="year"><%=yearPart%></option>
				<option value="substr"><%=substringFunction%></option>
				<option value="trim"><%=stripTrailingBlanks%></option>
				<option value="left"><%=leftJustify%></option>
				<option value="right"><%=rightJustify%></option>
				<option value="upcase"><%=upperCase%></option>
				<option value="lowcase"><%=lowerCase%></option>
				<option value="datepart"><%=datePart%></option>
				<option value="timepart"><%=timePart%></option>
			</select>
			</TR>	
			<script>
				document.<%=formname%>.dataType.options[0].selected = true;
			</script>
		<%	
	
	
	}
	
%>
<TR>
<TD>
	<input type="button" name="constant" CLASS="button" value="&nbsp;<%=constant%>&nbsp;" onClick="enterConstant();">
</TD>
<TD>
	<input type="button" name="undo" CLASS="button" value="<%=undo%>" onClick="undoLastChange ();">
	<!--add button class -->&nbsp;&nbsp;&nbsp;&nbsp;
	<input type="button" name="clear" CLASS="button" value="&nbsp;&nbsp;<%=clear%>&nbsp;&nbsp;" onClick="document.<%=formname%>.<%=selectedTextarea%>.value = ''; initialDisplay();">
</TD>
<TD>
</TD>

<TD>
	<INPUT ID="rbTLV" TYPE="RADIO" NAME="TLV" VALUE="TLV" onClick="processFunction('TLV');" onKeyPress="processFunction('TLV');"><LABEL FOR="rbTLV"><%=tlv%></LABEL></br>
	<INPUT ID="rbTLP" TYPE="RADIO" NAME="TLP" VALUE="TLP" onClick="processFunction('TLP');" onKeyPress="processFunction('TLP');"><LABEL FOR="rbTLP"><%=tlp%></LABEL></br>
	<INPUT ID="rbTEX" TYPE="RADIO" NAME="TEX" VALUE="TEX" onClick="processFunction('TEX');" onKeyPress="processFunction('TEX');"><LABEL FOR="rbTEX"><%=tex%></LABEL></br>
</TD>
</TR>
</TABLE>
<%
	String active = "";
	if(selectedTextarea.equalsIgnoreCase("expr")){
		active = "true";
	%>
		<script language="JavaScript">
			document.<%=formname%>.<%=selectedTextarea%>.value = '';
		</script>
	<%}
	else{
		active = "false";
		%>
			<script language="JavaScript">
				//set the focus on the correct data type
				document.<%=formname%>.dataType.selectedIndex = -1;
				document.<%=formname%>.dataType.disabled = true;
				document.<%=formname%>.<%=columnName%>.disabled = true;
				document.<%=formname%>.constant.disabled = true; 
				document.<%=formname%>.undo.disabled = true;
				var editExpression = document.<%=formname%>.<%=selectedTextarea%>.value;
				addToUndoStack('<%=columnName%>', editExpression);
			</script>
		<%
	}
%>
<script language="JavaScript">
	if(writeType == "dateTime")
		document.<%=formname%>.constant.disabled=true;
	//disable and sets the correct items on load
	document.<%=formname%>.TLV.disabled = <%=active%>;
	document.<%=formname%>.TLP.disabled = <%=active%>;
	document.<%=formname%>.TEX.disabled = <%=active%>;
	document.<%=formname%>.<%=func%>.disabled = <%=active%>;
	document.<%=formname%>.<%=operatorName%>.disabled = <%=active%>;
</script>
